/*
 * The FUJABA ToolSuite project:
 *
 *   FUJABA is the acronym for 'From Uml to Java And Back Again'
 *   and originally aims to provide an environment for round-trip
 *   engineering using UML as visual programming language. During
 *   the last years, the environment has become a base for several
 *   research activities, e.g. distributed software, database
 *   systems, modelling mechanical and electrical systems and
 *   their simulation. Thus, the environment has become a project,
 *   where this source code is part of. Further details are avail-
 *   able via http://www.fujaba.de
 *
 *      Copyright (C) 1997-2004 Fujaba Development Group
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA 02111-1307, USA or download the license under
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * WARRANTY:
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Lesser General Public License for more details.
 *
 * Contact adress:
 *
 *   Fujaba Management Board
 *   Software Engineering Group
 *   University of Paderborn
 *   Warburgerstr. 100
 *   D-33098 Paderborn
 *   Germany
 *
 *   URL  : http://www.fujaba.de
 *   email: info@fujaba.de
 *
 */
package de.uni_paderborn.fujaba.codegen;

import java.util.Iterator;


/**
 * No comment provided by developer, please add a comment to improve documentation.
 *
 * @author    $Author: schneider $
 * @version   $Revision: 1.8 $
 */
public class OOSwitchCaseStatement
    extends OOStatement
{
   /**
    * Default Constructor
    *
    * @param variable  No description provided
    * @param cases     No description provided
    */
   public OOSwitchCaseStatement (OOVariable variable, Iterator cases)
   {
      setVariable (variable);
      setCases (cases);
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private OOVariable variable;


   /**
    * Sets the variable attribute of the OOSwitchCaseStatement object
    *
    * @param variable  The new variable value
    */
   public void setVariable (OOVariable variable)
   {
      this.variable = variable;
   }


   /**
    * Get the variable attribute of the OOSwitchCaseStatement object
    *
    * @return   The variable value
    */
   public OOVariable getVariable()
   {
      return variable;
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private Iterator cases;


   /**
    * Sets the cases attribute of the OOSwitchCaseStatement object
    *
    * @param cases  The new cases value
    */
   public void setCases (Iterator cases)
   {
      this.cases = cases;
   }


   /**
    * Get the cases attribute of the OOSwitchCaseStatement object
    *
    * @return   The cases value
    */
   public Iterator getCases()
   {
      return cases;
   }


   /**
    * Get the sourceCode attribute of the OOSwitchCaseStatement object
    *
    * @param visitor  No description provided
    * @return         The sourceCode value
    */
   public String getSourceCode (OOGenVisitor visitor)
   {
      return visitor.getSourceCode (this);
   }


   /**
    * @return   short string representation of current object
    */
   public String toString()
   {
      return "OOSwitchStatement[]";
   }
}

/*
 * $Log: OOSwitchCaseStatement.java,v $
 * Revision 1.8  2004/10/20 17:49:34  schneider
 * Introduction of interfaces for class diagram classes
 *
 */
