package de.upb.inferenceengine.engines;

import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.upb.javaast.methodast.MethodCallNode;
import de.upb.javaast.methodast.IdentifierNode;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.ASTRootNode;

public class AssocSetMethodEngine
extends GFRNEngine
{
   private  AssocSetMethodEngine()
   {
   }

   private static AssocSetMethodEngine theAssocSetMethodEngine;

   public static AssocSetMethodEngine get()
   {
      if (theAssocSetMethodEngine == null)
      {
         theAssocSetMethodEngine = new AssocSetMethodEngine ();
      }
      return theAssocSetMethodEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation assocSetMethod = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         assocSetMethod = this.annotateUsingTrigger_AttributeAccessRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( assocSetMethod != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (assocSetMethod) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            assocSetMethod = this.annotateUsingReferenceRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( assocSetMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (assocSetMethod) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               assocSetMethod = this.annotateUsingSetMethodRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            try
            {
               fujaba__Success = false ;
                
               // constraint
               JavaSDM.ensure ( assocSetMethod != null ) ;
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            if ( fujaba__Success )
            {
               return (assocSetMethod) ;
            }
            else
            {
               try
               {
                  fujaba__Success = false ;
                   
                  // collabStatBegin 1 is empty !
                  assocSetMethod = this.annotateUsingCalledMethodRole(asgElement);
                   
                  // collabStatEnd
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               return (assocSetMethod) ;
            }
         }
      }
   }


   private GFRNAnnotation annotateUsingCalledMethodRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterASTRootNode15ToMethodCallNode16 = null ;
      ASTRootNode aSTRootNode15 = null ;
      AssocSetMethodAnnotation assocSetMethod = null ;
      AttributeAccessAnnotation attributeAccess13 = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterCalleeAnnotationsAssocSetMethod = null ;
      Iterator fujaba__IterReference14ElementsReferencingField = null ;
      Iterator fujaba__IterReferencedClassAnnotationsReference14 = null ;
      Iterator fujaba__IterReferencingClassMethodsSetter = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsAttributeAccess13 = null ;
      IdentifierNode id = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode16 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference14 = null ;
      UMLAttr referencingField = null ;
      UMLClass referencedClass = null ;
      UMLClass referencingClass = null ;
      UMLMethod callee = null ;
      UMLMethod setter = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("calledMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            callee = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind referencedClass: UMLClass
            referencedClass = callee.getParent () ;
            JavaSDM.ensure ( referencedClass != null ) ;
             
            // bind reference14: ReferenceAnnotation
            fujaba__IterReferencedClassAnnotationsReference14 = referencedClass.iteratorOfAnnotations () ;
            while ( fujaba__IterReferencedClassAnnotationsReference14.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReferencedClassAnnotationsReference14.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                  reference14 = (ReferenceAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between reference14 and referencedClass
                  JavaSDM.ensure ( reference14.hasInElements ("references", referencedClass) ) ;
                   
                  // bind referencingField: UMLAttr
                  fujaba__IterReference14ElementsReferencingField = reference14.iteratorOfElements ("field") ;
                  while ( fujaba__IterReference14ElementsReferencingField.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterReference14ElementsReferencingField.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        referencingField = (UMLAttr) fujaba__TmpObject ;
                         
                        // bind referencingClass: UMLClass
                        referencingClass = referencingField.getParent () ;
                        JavaSDM.ensure ( referencingClass != null ) ;
                         
                        // bind attributeAccess13: AttributeAccessAnnotation
                        fujaba__IterReferencingFieldAnnotationsAttributeAccess13 = referencingField.iteratorOfAnnotations () ;
                        while ( fujaba__IterReferencingFieldAnnotationsAttributeAccess13.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsAttributeAccess13.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof AttributeAccessAnnotation ) ;
                              attributeAccess13 = (AttributeAccessAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between attributeAccess13 and referencingField
                              JavaSDM.ensure ( attributeAccess13.hasInElements ("field", referencingField) ) ;
                               
                              // bind setter: UMLMethod
                              fujaba__IterReferencingClassMethodsSetter = referencingClass.iteratorOfMethods () ;
                              while ( fujaba__IterReferencingClassMethodsSetter.hasNext () )
                              {
                                 try
                                 {
                                    setter = (UMLMethod) fujaba__IterReferencingClassMethodsSetter.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callee.equals (setter)) ) ;
                                     
                                    // check To-Many-Link 'elements' between attributeAccess13 and setter
                                    JavaSDM.ensure ( attributeAccess13.hasInElements ("method", setter) ) ;
                                     
                                    // bind aSTRootNode15: ASTRootNode
                                    aSTRootNode15 = setter.getASTRootNode () ;
                                    JavaSDM.ensure ( aSTRootNode15 != null ) ;
                                     
                                    // Path search between ASTRootNode and MethodCallNode
                                    // Bind methodCallNode16 : MethodCallNode
                                    fujaba__IterASTRootNode15ToMethodCallNode16 = new ASTPathVisitor (aSTRootNode15, MethodCallNode.class ) ;
                                    while ( fujaba__IterASTRootNode15ToMethodCallNode16.hasNext () )
                                    {
                                       try
                                       {
                                          methodCallNode16 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterASTRootNode15ToMethodCallNode16.next () ;
                                           
                                          // bind id: IdentifierNode
                                          id = methodCallNode16.getIdentifier () ;
                                          JavaSDM.ensure ( id != null ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object setter is really bound
                                                JavaSDM.ensure ( setter != null ) ;
                                                 
                                                // check object callee is really bound
                                                JavaSDM.ensure ( callee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                 
                                                // check object reference14 is really bound
                                                JavaSDM.ensure ( reference14 != null ) ;
                                                 
                                                // bind assocSetMethod: AssocSetMethodAnnotation
                                                fujaba__IterCalleeAnnotationsAssocSetMethod = callee.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterCalleeAnnotationsAssocSetMethod.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterCalleeAnnotationsAssocSetMethod.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                                                      assocSetMethod = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between assocSetMethod and callee
                                                      JavaSDM.ensure ( assocSetMethod.hasInElements ("calledMethod", callee) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between assocSetMethod and setter
                                                      JavaSDM.ensure ( assocSetMethod.hasInElements ("setMethod", setter) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between assocSetMethod and reference14
                                                      JavaSDM.ensure ( assocSetMethod.hasInElements ("reference", reference14) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object setter is really bound
                                                   JavaSDM.ensure ( setter != null ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                    
                                                   // check object reference14 is really bound
                                                   JavaSDM.ensure ( reference14 != null ) ;
                                                    
                                                   // check object referencingField is really bound
                                                   JavaSDM.ensure ( referencingField != null ) ;
                                                    
                                                   // check object id is really bound
                                                   JavaSDM.ensure ( id != null ) ;
                                                    
                                                   // check object referencingClass is really bound
                                                   JavaSDM.ensure ( referencingClass != null ) ;
                                                    
                                                   // check object referencedClass is really bound
                                                   JavaSDM.ensure ( referencedClass != null ) ;
                                                    
                                                   // create object
                                                   assocSetMethod = new AssocSetMethodAnnotation ( ) ;
                                                    
                                                   // assign statement
                                                   assocSetMethod.setClassification (0);
                                                    
                                                   // create link
                                                   assocSetMethod.addToElements ("setMethod", setter);
                                                    
                                                   // create link
                                                   assocSetMethod.addToElements ("calledMethod", callee);
                                                    
                                                   // create link
                                                   assocSetMethod.addToElements ("reference", reference14);
                                                    
                                                   // create link
                                                   assocSetMethod.addToBoundObjects ("referencingField", referencingField);
                                                    
                                                   // create link
                                                   assocSetMethod.addToBoundObjects ("setter", setter);
                                                    
                                                   // create link
                                                   assocSetMethod.addToBoundObjects ("id", id);
                                                    
                                                   // create link
                                                   assocSetMethod.addToBoundObjects ("referencingClass", referencingClass);
                                                    
                                                   // create link
                                                   assocSetMethod.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   assocSetMethod.addToBoundObjects ("referencedClass", referencedClass);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object attributeAccess13 is really bound
                                                   JavaSDM.ensure ( attributeAccess13 != null ) ;
                                                    
                                                   // check object reference14 is really bound
                                                   JavaSDM.ensure ( reference14 != null ) ;
                                                    
                                                   // check object assocSetMethod is really bound
                                                   JavaSDM.ensure ( assocSetMethod != null ) ;
                                                    
                                                   // create link
                                                   assocSetMethod.addToAntecedentAnnos (attributeAccess13);
                                                    
                                                   // create link
                                                   assocSetMethod.addToAntecedentAnnos (reference14);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (assocSetMethod) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assocSetMethod is really bound
            JavaSDM.ensure ( assocSetMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("calledMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (assocSetMethod) ;
   }


   private GFRNAnnotation annotateUsingReferenceRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterASTRootNode7ToMethodCallNode8 = null ;
      ASTRootNode aSTRootNode7 = null ;
      AssocSetMethodAnnotation assocSetMethod = null ;
      AttributeAccessAnnotation attributeAccess5 = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterReference6AnnotationsAssocSetMethod = null ;
      Iterator fujaba__IterReference6ElementsReferencedClass = null ;
      Iterator fujaba__IterReference6ElementsReferencingField = null ;
      Iterator fujaba__IterReferencedClassMethodsCallee = null ;
      Iterator fujaba__IterReferencingClassMethodsSetter = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsAttributeAccess5 = null ;
      IdentifierNode id = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference6 = null ;
      UMLAttr referencingField = null ;
      UMLClass referencedClass = null ;
      UMLClass referencingClass = null ;
      UMLMethod callee = null ;
      UMLMethod setter = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("reference", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference6 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReference6ElementsReferencingField = reference6.iteratorOfElements ("field") ;
            while ( fujaba__IterReference6ElementsReferencingField.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference6ElementsReferencingField.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  referencingField = (UMLAttr) fujaba__TmpObject ;
                   
                  // bind referencingClass: UMLClass
                  referencingClass = referencingField.getParent () ;
                  JavaSDM.ensure ( referencingClass != null ) ;
                   
                  // bind referencedClass: UMLClass
                  fujaba__IterReference6ElementsReferencedClass = reference6.iteratorOfElements ("references") ;
                  while ( fujaba__IterReference6ElementsReferencedClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterReference6ElementsReferencedClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        referencedClass = (UMLClass) fujaba__TmpObject ;
                         
                        // bind attributeAccess5: AttributeAccessAnnotation
                        fujaba__IterReferencingFieldAnnotationsAttributeAccess5 = referencingField.iteratorOfAnnotations () ;
                        while ( fujaba__IterReferencingFieldAnnotationsAttributeAccess5.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsAttributeAccess5.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof AttributeAccessAnnotation ) ;
                              attributeAccess5 = (AttributeAccessAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between attributeAccess5 and referencingField
                              JavaSDM.ensure ( attributeAccess5.hasInElements ("field", referencingField) ) ;
                               
                              // bind setter: UMLMethod
                              fujaba__IterReferencingClassMethodsSetter = referencingClass.iteratorOfMethods () ;
                              while ( fujaba__IterReferencingClassMethodsSetter.hasNext () )
                              {
                                 try
                                 {
                                    setter = (UMLMethod) fujaba__IterReferencingClassMethodsSetter.next () ;
                                     
                                    // check To-Many-Link 'elements' between attributeAccess5 and setter
                                    JavaSDM.ensure ( attributeAccess5.hasInElements ("method", setter) ) ;
                                     
                                    // bind aSTRootNode7: ASTRootNode
                                    aSTRootNode7 = setter.getASTRootNode () ;
                                    JavaSDM.ensure ( aSTRootNode7 != null ) ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterReferencedClassMethodsCallee = referencedClass.iteratorOfMethods () ;
                                    while ( fujaba__IterReferencedClassMethodsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          callee = (UMLMethod) fujaba__IterReferencedClassMethodsCallee.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                           
                                          // Path search between ASTRootNode and MethodCallNode
                                          // Bind methodCallNode8 : MethodCallNode
                                          fujaba__IterASTRootNode7ToMethodCallNode8 = new ASTPathVisitor (aSTRootNode7, MethodCallNode.class ) ;
                                          while ( fujaba__IterASTRootNode7ToMethodCallNode8.hasNext () )
                                          {
                                             try
                                             {
                                                methodCallNode8 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterASTRootNode7ToMethodCallNode8.next () ;
                                                 
                                                // bind id: IdentifierNode
                                                id = methodCallNode8.getIdentifier () ;
                                                JavaSDM.ensure ( id != null ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object setter is really bound
                                                      JavaSDM.ensure ( setter != null ) ;
                                                       
                                                      // check object callee is really bound
                                                      JavaSDM.ensure ( callee != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                       
                                                      // check object reference6 is really bound
                                                      JavaSDM.ensure ( reference6 != null ) ;
                                                       
                                                      // bind assocSetMethod: AssocSetMethodAnnotation
                                                      fujaba__IterReference6AnnotationsAssocSetMethod = reference6.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterReference6AnnotationsAssocSetMethod.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterReference6AnnotationsAssocSetMethod.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                                                            assocSetMethod = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between assocSetMethod and reference6
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("reference", reference6) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between assocSetMethod and setter
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("setMethod", setter) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between assocSetMethod and callee
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("calledMethod", callee) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object setter is really bound
                                                         JavaSDM.ensure ( setter != null ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                          
                                                         // check object reference6 is really bound
                                                         JavaSDM.ensure ( reference6 != null ) ;
                                                          
                                                         // check object referencingField is really bound
                                                         JavaSDM.ensure ( referencingField != null ) ;
                                                          
                                                         // check object id is really bound
                                                         JavaSDM.ensure ( id != null ) ;
                                                          
                                                         // check object referencingClass is really bound
                                                         JavaSDM.ensure ( referencingClass != null ) ;
                                                          
                                                         // check object referencedClass is really bound
                                                         JavaSDM.ensure ( referencedClass != null ) ;
                                                          
                                                         // create object
                                                         assocSetMethod = new AssocSetMethodAnnotation ( ) ;
                                                          
                                                         // assign statement
                                                         assocSetMethod.setClassification (0);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("setMethod", setter);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("calledMethod", callee);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("reference", reference6);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencingField", referencingField);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("setter", setter);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("id", id);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencingClass", referencingClass);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencedClass", referencedClass);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object attributeAccess5 is really bound
                                                         JavaSDM.ensure ( attributeAccess5 != null ) ;
                                                          
                                                         // check object reference6 is really bound
                                                         JavaSDM.ensure ( reference6 != null ) ;
                                                          
                                                         // check object assocSetMethod is really bound
                                                         JavaSDM.ensure ( assocSetMethod != null ) ;
                                                          
                                                         // create link
                                                         assocSetMethod.addToAntecedentAnnos (attributeAccess5);
                                                          
                                                         // create link
                                                         assocSetMethod.addToAntecedentAnnos (reference6);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (assocSetMethod) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assocSetMethod is really bound
            JavaSDM.ensure ( assocSetMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("reference", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (assocSetMethod) ;
   }


   private GFRNAnnotation annotateUsingSetMethodRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterASTRootNode11ToMethodCallNode12 = null ;
      ASTRootNode aSTRootNode11 = null ;
      AssocSetMethodAnnotation assocSetMethod = null ;
      AttributeAccessAnnotation attributeAccess9 = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterReference10ElementsReferencedClass = null ;
      Iterator fujaba__IterReferencedClassMethodsCallee = null ;
      Iterator fujaba__IterReferencingClassAttrsReferencingField = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReference10 = null ;
      Iterator fujaba__IterSetterAnnotationsAssocSetMethod = null ;
      Iterator fujaba__IterSetterAnnotationsAttributeAccess9 = null ;
      IdentifierNode id = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode12 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference10 = null ;
      UMLAttr referencingField = null ;
      UMLClass referencedClass = null ;
      UMLClass referencingClass = null ;
      UMLMethod callee = null ;
      UMLMethod setter = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("setMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            setter = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind aSTRootNode11: ASTRootNode
            aSTRootNode11 = setter.getASTRootNode () ;
            JavaSDM.ensure ( aSTRootNode11 != null ) ;
             
            // bind referencingClass: UMLClass
            referencingClass = setter.getParent () ;
            JavaSDM.ensure ( referencingClass != null ) ;
             
            // bind attributeAccess9: AttributeAccessAnnotation
            fujaba__IterSetterAnnotationsAttributeAccess9 = setter.iteratorOfAnnotations () ;
            while ( fujaba__IterSetterAnnotationsAttributeAccess9.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSetterAnnotationsAttributeAccess9.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AttributeAccessAnnotation ) ;
                  attributeAccess9 = (AttributeAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between attributeAccess9 and setter
                  JavaSDM.ensure ( attributeAccess9.hasInElements ("method", setter) ) ;
                   
                  // bind referencingField: UMLAttr
                  fujaba__IterReferencingClassAttrsReferencingField = referencingClass.iteratorOfAttrs () ;
                  while ( fujaba__IterReferencingClassAttrsReferencingField.hasNext () )
                  {
                     try
                     {
                        referencingField = (UMLAttr) fujaba__IterReferencingClassAttrsReferencingField.next () ;
                         
                        // check To-Many-Link 'elements' between attributeAccess9 and referencingField
                        JavaSDM.ensure ( attributeAccess9.hasInElements ("field", referencingField) ) ;
                         
                        // bind reference10: ReferenceAnnotation
                        fujaba__IterReferencingFieldAnnotationsReference10 = referencingField.iteratorOfAnnotations () ;
                        while ( fujaba__IterReferencingFieldAnnotationsReference10.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReference10.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference10 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference10 and referencingField
                              JavaSDM.ensure ( reference10.hasInElements ("field", referencingField) ) ;
                               
                              // bind referencedClass: UMLClass
                              fujaba__IterReference10ElementsReferencedClass = reference10.iteratorOfElements ("references") ;
                              while ( fujaba__IterReference10ElementsReferencedClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterReference10ElementsReferencedClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    referencedClass = (UMLClass) fujaba__TmpObject ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterReferencedClassMethodsCallee = referencedClass.iteratorOfMethods () ;
                                    while ( fujaba__IterReferencedClassMethodsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          callee = (UMLMethod) fujaba__IterReferencedClassMethodsCallee.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                           
                                          // Path search between ASTRootNode and MethodCallNode
                                          // Bind methodCallNode12 : MethodCallNode
                                          fujaba__IterASTRootNode11ToMethodCallNode12 = new ASTPathVisitor (aSTRootNode11, MethodCallNode.class ) ;
                                          while ( fujaba__IterASTRootNode11ToMethodCallNode12.hasNext () )
                                          {
                                             try
                                             {
                                                methodCallNode12 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterASTRootNode11ToMethodCallNode12.next () ;
                                                 
                                                // bind id: IdentifierNode
                                                id = methodCallNode12.getIdentifier () ;
                                                JavaSDM.ensure ( id != null ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object setter is really bound
                                                      JavaSDM.ensure ( setter != null ) ;
                                                       
                                                      // check object callee is really bound
                                                      JavaSDM.ensure ( callee != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                       
                                                      // check object reference10 is really bound
                                                      JavaSDM.ensure ( reference10 != null ) ;
                                                       
                                                      // bind assocSetMethod: AssocSetMethodAnnotation
                                                      fujaba__IterSetterAnnotationsAssocSetMethod = setter.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterSetterAnnotationsAssocSetMethod.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterSetterAnnotationsAssocSetMethod.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                                                            assocSetMethod = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between assocSetMethod and setter
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("setMethod", setter) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between assocSetMethod and callee
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("calledMethod", callee) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between assocSetMethod and reference10
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("reference", reference10) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object setter is really bound
                                                         JavaSDM.ensure ( setter != null ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                          
                                                         // check object reference10 is really bound
                                                         JavaSDM.ensure ( reference10 != null ) ;
                                                          
                                                         // check object referencingField is really bound
                                                         JavaSDM.ensure ( referencingField != null ) ;
                                                          
                                                         // check object id is really bound
                                                         JavaSDM.ensure ( id != null ) ;
                                                          
                                                         // check object referencingClass is really bound
                                                         JavaSDM.ensure ( referencingClass != null ) ;
                                                          
                                                         // check object referencedClass is really bound
                                                         JavaSDM.ensure ( referencedClass != null ) ;
                                                          
                                                         // create object
                                                         assocSetMethod = new AssocSetMethodAnnotation ( ) ;
                                                          
                                                         // assign statement
                                                         assocSetMethod.setClassification (0);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("setMethod", setter);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("calledMethod", callee);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("reference", reference10);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencingField", referencingField);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("setter", setter);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("id", id);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencingClass", referencingClass);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencedClass", referencedClass);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object attributeAccess9 is really bound
                                                         JavaSDM.ensure ( attributeAccess9 != null ) ;
                                                          
                                                         // check object reference10 is really bound
                                                         JavaSDM.ensure ( reference10 != null ) ;
                                                          
                                                         // check object assocSetMethod is really bound
                                                         JavaSDM.ensure ( assocSetMethod != null ) ;
                                                          
                                                         // create link
                                                         assocSetMethod.addToAntecedentAnnos (attributeAccess9);
                                                          
                                                         // create link
                                                         assocSetMethod.addToAntecedentAnnos (reference10);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (assocSetMethod) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assocSetMethod is really bound
            JavaSDM.ensure ( assocSetMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("setMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (assocSetMethod) ;
   }


   private GFRNAnnotation annotateUsingTrigger_AttributeAccessRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterASTRootNode3ToMethodCallNode4 = null ;
      ASTRootNode aSTRootNode3 = null ;
      AssocSetMethodAnnotation assocSetMethod = null ;
      AttributeAccessAnnotation attributeAccess1 = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAttributeAccess1ElementsReferencingField = null ;
      Iterator fujaba__IterAttributeAccess1ElementsSetter = null ;
      Iterator fujaba__IterReference2AnnotationsAssocSetMethod = null ;
      Iterator fujaba__IterReference2ElementsReferencedClass = null ;
      Iterator fujaba__IterReferencedClassMethodsCallee = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReference2 = null ;
      IdentifierNode id = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode4 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference2 = null ;
      UMLAttr referencingField = null ;
      UMLClass referencedClass = null ;
      UMLClass referencingClass = null ;
      UMLMethod callee = null ;
      UMLMethod setter = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_AttributeAccess", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AttributeAccessAnnotation ) ;
             
            // explicit type cast
            attributeAccess1 = (AttributeAccessAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterAttributeAccess1ElementsReferencingField = attributeAccess1.iteratorOfElements ("field") ;
            while ( fujaba__IterAttributeAccess1ElementsReferencingField.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAttributeAccess1ElementsReferencingField.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  referencingField = (UMLAttr) fujaba__TmpObject ;
                   
                  // bind referencingClass: UMLClass
                  referencingClass = referencingField.getParent () ;
                  JavaSDM.ensure ( referencingClass != null ) ;
                   
                  // bind setter: UMLMethod
                  fujaba__IterAttributeAccess1ElementsSetter = attributeAccess1.iteratorOfElements ("method") ;
                  while ( fujaba__IterAttributeAccess1ElementsSetter.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAttributeAccess1ElementsSetter.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        setter = (UMLMethod) fujaba__TmpObject ;
                         
                        // check To-One-Link 'parent' between setter and referencingClass
                        JavaSDM.ensure ( (setter.getParent () != null) && setter.getParent ().equals (referencingClass) ) ;
                         
                        // bind aSTRootNode3: ASTRootNode
                        aSTRootNode3 = setter.getASTRootNode () ;
                        JavaSDM.ensure ( aSTRootNode3 != null ) ;
                         
                        // bind reference2: ReferenceAnnotation
                        fujaba__IterReferencingFieldAnnotationsReference2 = referencingField.iteratorOfAnnotations () ;
                        while ( fujaba__IterReferencingFieldAnnotationsReference2.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReference2.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference2 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference2 and referencingField
                              JavaSDM.ensure ( reference2.hasInElements ("field", referencingField) ) ;
                               
                              // bind referencedClass: UMLClass
                              fujaba__IterReference2ElementsReferencedClass = reference2.iteratorOfElements ("references") ;
                              while ( fujaba__IterReference2ElementsReferencedClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterReference2ElementsReferencedClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    referencedClass = (UMLClass) fujaba__TmpObject ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterReferencedClassMethodsCallee = referencedClass.iteratorOfMethods () ;
                                    while ( fujaba__IterReferencedClassMethodsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          callee = (UMLMethod) fujaba__IterReferencedClassMethodsCallee.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                           
                                          // Path search between ASTRootNode and MethodCallNode
                                          // Bind methodCallNode4 : MethodCallNode
                                          fujaba__IterASTRootNode3ToMethodCallNode4 = new ASTPathVisitor (aSTRootNode3, MethodCallNode.class ) ;
                                          while ( fujaba__IterASTRootNode3ToMethodCallNode4.hasNext () )
                                          {
                                             try
                                             {
                                                methodCallNode4 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterASTRootNode3ToMethodCallNode4.next () ;
                                                 
                                                // bind id: IdentifierNode
                                                id = methodCallNode4.getIdentifier () ;
                                                JavaSDM.ensure ( id != null ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object setter is really bound
                                                      JavaSDM.ensure ( setter != null ) ;
                                                       
                                                      // check object callee is really bound
                                                      JavaSDM.ensure ( callee != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                       
                                                      // check object reference2 is really bound
                                                      JavaSDM.ensure ( reference2 != null ) ;
                                                       
                                                      // bind assocSetMethod: AssocSetMethodAnnotation
                                                      fujaba__IterReference2AnnotationsAssocSetMethod = reference2.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterReference2AnnotationsAssocSetMethod.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterReference2AnnotationsAssocSetMethod.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                                                            assocSetMethod = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between assocSetMethod and reference2
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("reference", reference2) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between assocSetMethod and setter
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("setMethod", setter) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between assocSetMethod and callee
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("calledMethod", callee) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object setter is really bound
                                                         JavaSDM.ensure ( setter != null ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                          
                                                         // check object reference2 is really bound
                                                         JavaSDM.ensure ( reference2 != null ) ;
                                                          
                                                         // check object referencingField is really bound
                                                         JavaSDM.ensure ( referencingField != null ) ;
                                                          
                                                         // check object id is really bound
                                                         JavaSDM.ensure ( id != null ) ;
                                                          
                                                         // check object referencingClass is really bound
                                                         JavaSDM.ensure ( referencingClass != null ) ;
                                                          
                                                         // check object referencedClass is really bound
                                                         JavaSDM.ensure ( referencedClass != null ) ;
                                                          
                                                         // create object
                                                         assocSetMethod = new AssocSetMethodAnnotation ( ) ;
                                                          
                                                         // assign statement
                                                         assocSetMethod.setClassification (0);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("setMethod", setter);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("calledMethod", callee);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("reference", reference2);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencingField", referencingField);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("setter", setter);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("id", id);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencingClass", referencingClass);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencedClass", referencedClass);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object attributeAccess1 is really bound
                                                         JavaSDM.ensure ( attributeAccess1 != null ) ;
                                                          
                                                         // check object reference2 is really bound
                                                         JavaSDM.ensure ( reference2 != null ) ;
                                                          
                                                         // check object assocSetMethod is really bound
                                                         JavaSDM.ensure ( assocSetMethod != null ) ;
                                                          
                                                         // create link
                                                         assocSetMethod.addToAntecedentAnnos (attributeAccess1);
                                                          
                                                         // create link
                                                         assocSetMethod.addToAntecedentAnnos (reference2);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (assocSetMethod) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assocSetMethod is really bound
            JavaSDM.ensure ( assocSetMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_AttributeAccess", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (assocSetMethod) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("setMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("calledMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("reference", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof AttributeAccessAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_AttributeAccess", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      AttributeAccessAnnotation attributeAccess18 = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAttributeAccess18ElementsReferencingField = null ;
      Iterator fujaba__IterReference17ElementsReferencingField = null ;
      Iterator fujaba__IterReferencedClassAnnotationsReference17 = null ;
      Iterator fujaba__IterSetterAnnotationsAttributeAccess18 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference17 = null ;
      UMLAttr referencingField = null ;
      UMLClass referencedClass = null ;
      UMLMethod callee = null ;
      UMLMethod setter = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("AttributeAccess") || annotation.equals ("ContainerAccess") || annotation.equals ("SetMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            setter = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (setter);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            callee = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind referencedClass: UMLClass
            referencedClass = callee.getParent () ;
            JavaSDM.ensure ( referencedClass != null ) ;
             
            // bind reference17: ReferenceAnnotation
            fujaba__IterReferencedClassAnnotationsReference17 = referencedClass.iteratorOfAnnotations () ;
            while ( fujaba__IterReferencedClassAnnotationsReference17.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReferencedClassAnnotationsReference17.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                  reference17 = (ReferenceAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between reference17 and referencedClass
                  JavaSDM.ensure ( reference17.hasInElements ("references", referencedClass) ) ;
                   
                  // bind referencingField: UMLAttr
                  fujaba__IterReference17ElementsReferencingField = reference17.iteratorOfElements ("field") ;
                  while ( fujaba__IterReference17ElementsReferencingField.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterReference17ElementsReferencingField.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        referencingField = (UMLAttr) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (referencingField);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference17 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReference17ElementsReferencingField = reference17.iteratorOfElements ("field") ;
            while ( fujaba__IterReference17ElementsReferencingField.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference17ElementsReferencingField.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  referencingField = (UMLAttr) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference17 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReference17ElementsReferencingField = reference17.iteratorOfElements ("field") ;
            while ( fujaba__IterReference17ElementsReferencingField.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference17ElementsReferencingField.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  referencingField = (UMLAttr) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Reference") || annotation.equals ("QualifiedReference") || annotation.equals ("MultiReference") || annotation.equals ("SingleReference") || annotation.equals ("ArrayMultiReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            setter = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind attributeAccess18: AttributeAccessAnnotation
            fujaba__IterSetterAnnotationsAttributeAccess18 = setter.iteratorOfAnnotations () ;
            while ( fujaba__IterSetterAnnotationsAttributeAccess18.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSetterAnnotationsAttributeAccess18.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AttributeAccessAnnotation ) ;
                  attributeAccess18 = (AttributeAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between attributeAccess18 and setter
                  JavaSDM.ensure ( attributeAccess18.hasInElements ("method", setter) ) ;
                   
                  // bind referencingField: UMLAttr
                  fujaba__IterAttributeAccess18ElementsReferencingField = attributeAccess18.iteratorOfElements ("field") ;
                  while ( fujaba__IterAttributeAccess18ElementsReferencingField.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAttributeAccess18ElementsReferencingField.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        referencingField = (UMLAttr) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (referencingField);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            callee = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind referencedClass: UMLClass
            referencedClass = callee.getParent () ;
            JavaSDM.ensure ( referencedClass != null ) ;
             
            {
               //  for each flow
               set.add (referencedClass);
            } //  end for each flow
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AttributeAccessAnnotation ) ;
             
            // explicit type cast
            attributeAccess18 = (AttributeAccessAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterAttributeAccess18ElementsReferencingField = attributeAccess18.iteratorOfElements ("field") ;
            while ( fujaba__IterAttributeAccess18ElementsReferencingField.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAttributeAccess18ElementsReferencingField.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  referencingField = (UMLAttr) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
