package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class CompositeEngine
extends GFRNEngine
{
   private  CompositeEngine()
   {
   }

   private static CompositeEngine theCompositeEngine;

   public static CompositeEngine get()
   {
      if (theCompositeEngine == null)
      {
         theCompositeEngine = new CompositeEngine ();
      }
      return theCompositeEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation composite = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         composite = this.annotateUsingTrigger_OneToManyAssociationRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( composite != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (composite) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            composite = this.annotateUsingTrigger_GeneralizationRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( composite != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (composite) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               composite = this.annotateUsingTrigger_MultiDelegationRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            try
            {
               fujaba__Success = false ;
                
               // constraint
               JavaSDM.ensure ( composite != null ) ;
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            if ( fujaba__Success )
            {
               return (composite) ;
            }
            else
            {
               try
               {
                  fujaba__Success = false ;
                   
                  // collabStatBegin 1 is empty !
                  composite = this.annotateUsingCompositeRole(asgElement);
                   
                  // collabStatEnd
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               try
               {
                  fujaba__Success = false ;
                   
                  // constraint
                  JavaSDM.ensure ( composite != null ) ;
                   
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               if ( fujaba__Success )
               {
                  return (composite) ;
               }
               else
               {
                  try
                  {
                     fujaba__Success = false ;
                      
                     // collabStatBegin 1 is empty !
                     composite = this.annotateUsingComponentRole(asgElement);
                      
                     // collabStatEnd
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  return (composite) ;
               }
            }
         }
      }
   }


   private GFRNAnnotation annotateUsingComponentRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CompositeAnnotation composite = null ;
      Iterator fujaba__IterCalleeAnnotationsMultiDelegation15 = null ;
      Iterator fujaba__IterComponentClassAnnotationsComposite = null ;
      Iterator fujaba__IterComponentClassAnnotationsGeneralization14 = null ;
      Iterator fujaba__IterComponentClassAnnotationsOneToManyAssociation13 = null ;
      Iterator fujaba__IterComponentClassMethodsCallee = null ;
      Iterator fujaba__IterGeneralization14ElementsCompositeClass = null ;
      Iterator fujaba__IterMultiDelegation15ElementsCaller = null ;
      GeneralizationAnnotation generalization14 = null ;
      MultiDelegationAnnotation multiDelegation15 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation13 = null ;
      UMLClass componentClass = null ;
      UMLClass compositeClass = null ;
      UMLMethod callee = null ;
      UMLMethod caller = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("component", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterComponentClassMethodsCallee = componentClass.iteratorOfMethods () ;
            while ( fujaba__IterComponentClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (UMLMethod) fujaba__IterComponentClassMethodsCallee.next () ;
                   
                  // bind generalization14: GeneralizationAnnotation
                  fujaba__IterComponentClassAnnotationsGeneralization14 = componentClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterComponentClassAnnotationsGeneralization14.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterComponentClassAnnotationsGeneralization14.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization14 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization14 and componentClass
                        JavaSDM.ensure ( generalization14.hasInElements ("superClass", componentClass) ) ;
                         
                        // bind oneToManyAssociation13: OneToManyAssociationAnnotation
                        fujaba__IterComponentClassAnnotationsOneToManyAssociation13 = componentClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterComponentClassAnnotationsOneToManyAssociation13.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterComponentClassAnnotationsOneToManyAssociation13.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                              oneToManyAssociation13 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between oneToManyAssociation13 and componentClass
                              JavaSDM.ensure ( oneToManyAssociation13.hasInElements ("many", componentClass) ) ;
                               
                              // bind multiDelegation15: MultiDelegationAnnotation
                              fujaba__IterCalleeAnnotationsMultiDelegation15 = callee.iteratorOfAnnotations () ;
                              while ( fujaba__IterCalleeAnnotationsMultiDelegation15.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCalleeAnnotationsMultiDelegation15.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof MultiDelegationAnnotation ) ;
                                    multiDelegation15 = (MultiDelegationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between multiDelegation15 and callee
                                    JavaSDM.ensure ( multiDelegation15.hasInElements ("callee", callee) ) ;
                                     
                                    // bind compositeClass: UMLClass
                                    fujaba__IterGeneralization14ElementsCompositeClass = generalization14.iteratorOfElements ("subClass") ;
                                    while ( fujaba__IterGeneralization14ElementsCompositeClass.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization14ElementsCompositeClass.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          compositeClass = (UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(componentClass.equals (compositeClass)) ) ;
                                           
                                          // check To-Many-Link 'elements' between oneToManyAssociation13 and compositeClass
                                          JavaSDM.ensure ( oneToManyAssociation13.hasInElements ("one", compositeClass) ) ;
                                           
                                          // bind caller: UMLMethod
                                          fujaba__IterMultiDelegation15ElementsCaller = multiDelegation15.iteratorOfElements ("caller") ;
                                          while ( fujaba__IterMultiDelegation15ElementsCaller.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterMultiDelegation15ElementsCaller.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                caller = (UMLMethod) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                 
                                                // check To-One-Link 'parent' between caller and compositeClass
                                                JavaSDM.ensure ( (caller.getParent () != null) && caller.getParent ().equals (compositeClass) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object compositeClass is really bound
                                                      JavaSDM.ensure ( compositeClass != null ) ;
                                                       
                                                      // check object componentClass is really bound
                                                      JavaSDM.ensure ( componentClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                                       
                                                      // bind composite: CompositeAnnotation
                                                      fujaba__IterComponentClassAnnotationsComposite = componentClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterComponentClassAnnotationsComposite.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterComponentClassAnnotationsComposite.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof CompositeAnnotation ) ;
                                                            composite = (CompositeAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between composite and componentClass
                                                            JavaSDM.ensure ( composite.hasInElements ("component", componentClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between composite and compositeClass
                                                            JavaSDM.ensure ( composite.hasInElements ("composite", compositeClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object compositeClass is really bound
                                                         JavaSDM.ensure ( compositeClass != null ) ;
                                                          
                                                         // check object componentClass is really bound
                                                         JavaSDM.ensure ( componentClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                          
                                                         // create object
                                                         composite = new CompositeAnnotation ( ) ;
                                                          
                                                         // assign statement
                                                         composite.setClassification (1);
                                                          
                                                         // create link
                                                         composite.addToElements ("composite", compositeClass);
                                                          
                                                         // create link
                                                         composite.addToElements ("component", componentClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("caller", caller);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("compositeClass", compositeClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("componentClass", componentClass);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object oneToManyAssociation13 is really bound
                                                         JavaSDM.ensure ( oneToManyAssociation13 != null ) ;
                                                          
                                                         // check object generalization14 is really bound
                                                         JavaSDM.ensure ( generalization14 != null ) ;
                                                          
                                                         // check object multiDelegation15 is really bound
                                                         JavaSDM.ensure ( multiDelegation15 != null ) ;
                                                          
                                                         // check object composite is really bound
                                                         JavaSDM.ensure ( composite != null ) ;
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (oneToManyAssociation13);
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (generalization14);
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (multiDelegation15);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (composite) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object composite is really bound
            JavaSDM.ensure ( composite != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("component", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (composite) ;
   }


   private GFRNAnnotation annotateUsingCompositeRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CompositeAnnotation composite = null ;
      Iterator fujaba__IterCallerAnnotationsMultiDelegation12 = null ;
      Iterator fujaba__IterCompositeClassAnnotationsComposite = null ;
      Iterator fujaba__IterCompositeClassAnnotationsGeneralization11 = null ;
      Iterator fujaba__IterCompositeClassAnnotationsOneToManyAssociation10 = null ;
      Iterator fujaba__IterCompositeClassMethodsCaller = null ;
      Iterator fujaba__IterGeneralization11ElementsComponentClass = null ;
      Iterator fujaba__IterMultiDelegation12ElementsCallee = null ;
      GeneralizationAnnotation generalization11 = null ;
      MultiDelegationAnnotation multiDelegation12 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation10 = null ;
      UMLClass componentClass = null ;
      UMLClass compositeClass = null ;
      UMLMethod callee = null ;
      UMLMethod caller = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("composite", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            compositeClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterCompositeClassMethodsCaller = compositeClass.iteratorOfMethods () ;
            while ( fujaba__IterCompositeClassMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (UMLMethod) fujaba__IterCompositeClassMethodsCaller.next () ;
                   
                  // bind generalization11: GeneralizationAnnotation
                  fujaba__IterCompositeClassAnnotationsGeneralization11 = compositeClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterCompositeClassAnnotationsGeneralization11.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCompositeClassAnnotationsGeneralization11.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization11 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization11 and compositeClass
                        JavaSDM.ensure ( generalization11.hasInElements ("subClass", compositeClass) ) ;
                         
                        // bind oneToManyAssociation10: OneToManyAssociationAnnotation
                        fujaba__IterCompositeClassAnnotationsOneToManyAssociation10 = compositeClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterCompositeClassAnnotationsOneToManyAssociation10.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCompositeClassAnnotationsOneToManyAssociation10.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                              oneToManyAssociation10 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between oneToManyAssociation10 and compositeClass
                              JavaSDM.ensure ( oneToManyAssociation10.hasInElements ("one", compositeClass) ) ;
                               
                              // bind multiDelegation12: MultiDelegationAnnotation
                              fujaba__IterCallerAnnotationsMultiDelegation12 = caller.iteratorOfAnnotations () ;
                              while ( fujaba__IterCallerAnnotationsMultiDelegation12.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCallerAnnotationsMultiDelegation12.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof MultiDelegationAnnotation ) ;
                                    multiDelegation12 = (MultiDelegationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between multiDelegation12 and caller
                                    JavaSDM.ensure ( multiDelegation12.hasInElements ("caller", caller) ) ;
                                     
                                    // bind componentClass: UMLClass
                                    fujaba__IterGeneralization11ElementsComponentClass = generalization11.iteratorOfElements ("superClass") ;
                                    while ( fujaba__IterGeneralization11ElementsComponentClass.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization11ElementsComponentClass.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          componentClass = (UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                           
                                          // check To-Many-Link 'elements' between oneToManyAssociation10 and componentClass
                                          JavaSDM.ensure ( oneToManyAssociation10.hasInElements ("many", componentClass) ) ;
                                           
                                          // bind callee: UMLMethod
                                          fujaba__IterMultiDelegation12ElementsCallee = multiDelegation12.iteratorOfElements ("callee") ;
                                          while ( fujaba__IterMultiDelegation12ElementsCallee.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterMultiDelegation12ElementsCallee.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                callee = (UMLMethod) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // check To-One-Link 'parent' between callee and componentClass
                                                JavaSDM.ensure ( (callee.getParent () != null) && callee.getParent ().equals (componentClass) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object compositeClass is really bound
                                                      JavaSDM.ensure ( compositeClass != null ) ;
                                                       
                                                      // check object componentClass is really bound
                                                      JavaSDM.ensure ( componentClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                                       
                                                      // bind composite: CompositeAnnotation
                                                      fujaba__IterCompositeClassAnnotationsComposite = compositeClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterCompositeClassAnnotationsComposite.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterCompositeClassAnnotationsComposite.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof CompositeAnnotation ) ;
                                                            composite = (CompositeAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between composite and compositeClass
                                                            JavaSDM.ensure ( composite.hasInElements ("composite", compositeClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between composite and componentClass
                                                            JavaSDM.ensure ( composite.hasInElements ("component", componentClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object compositeClass is really bound
                                                         JavaSDM.ensure ( compositeClass != null ) ;
                                                          
                                                         // check object componentClass is really bound
                                                         JavaSDM.ensure ( componentClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                          
                                                         // create object
                                                         composite = new CompositeAnnotation ( ) ;
                                                          
                                                         // assign statement
                                                         composite.setClassification (1);
                                                          
                                                         // create link
                                                         composite.addToElements ("composite", compositeClass);
                                                          
                                                         // create link
                                                         composite.addToElements ("component", componentClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("caller", caller);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("compositeClass", compositeClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("componentClass", componentClass);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object oneToManyAssociation10 is really bound
                                                         JavaSDM.ensure ( oneToManyAssociation10 != null ) ;
                                                          
                                                         // check object generalization11 is really bound
                                                         JavaSDM.ensure ( generalization11 != null ) ;
                                                          
                                                         // check object multiDelegation12 is really bound
                                                         JavaSDM.ensure ( multiDelegation12 != null ) ;
                                                          
                                                         // check object composite is really bound
                                                         JavaSDM.ensure ( composite != null ) ;
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (oneToManyAssociation10);
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (generalization11);
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (multiDelegation12);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (composite) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object composite is really bound
            JavaSDM.ensure ( composite != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("composite", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (composite) ;
   }


   private GFRNAnnotation annotateUsingTrigger_GeneralizationRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CompositeAnnotation composite = null ;
      Iterator fujaba__IterCallerAnnotationsMultiDelegation6 = null ;
      Iterator fujaba__IterComponentClassAnnotationsComposite = null ;
      Iterator fujaba__IterComponentClassMethodsCallee = null ;
      Iterator fujaba__IterCompositeClassAnnotationsOneToManyAssociation4 = null ;
      Iterator fujaba__IterCompositeClassMethodsCaller = null ;
      Iterator fujaba__IterGeneralization5ElementsComponentClass = null ;
      Iterator fujaba__IterGeneralization5ElementsCompositeClass = null ;
      GeneralizationAnnotation generalization5 = null ;
      MultiDelegationAnnotation multiDelegation6 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation4 = null ;
      UMLClass componentClass = null ;
      UMLClass compositeClass = null ;
      UMLMethod callee = null ;
      UMLMethod caller = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization5 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind compositeClass: UMLClass
            fujaba__IterGeneralization5ElementsCompositeClass = generalization5.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization5ElementsCompositeClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization5ElementsCompositeClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  compositeClass = (UMLClass) fujaba__TmpObject ;
                   
                  // bind componentClass: UMLClass
                  fujaba__IterGeneralization5ElementsComponentClass = generalization5.iteratorOfElements ("superClass") ;
                  while ( fujaba__IterGeneralization5ElementsComponentClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization5ElementsComponentClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        componentClass = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                         
                        // bind caller: UMLMethod
                        fujaba__IterCompositeClassMethodsCaller = compositeClass.iteratorOfMethods () ;
                        while ( fujaba__IterCompositeClassMethodsCaller.hasNext () )
                        {
                           try
                           {
                              caller = (UMLMethod) fujaba__IterCompositeClassMethodsCaller.next () ;
                               
                              // bind oneToManyAssociation4: OneToManyAssociationAnnotation
                              fujaba__IterCompositeClassAnnotationsOneToManyAssociation4 = compositeClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterCompositeClassAnnotationsOneToManyAssociation4.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCompositeClassAnnotationsOneToManyAssociation4.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                                    oneToManyAssociation4 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between oneToManyAssociation4 and compositeClass
                                    JavaSDM.ensure ( oneToManyAssociation4.hasInElements ("one", compositeClass) ) ;
                                     
                                    // check To-Many-Link 'elements' between oneToManyAssociation4 and componentClass
                                    JavaSDM.ensure ( oneToManyAssociation4.hasInElements ("many", componentClass) ) ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterComponentClassMethodsCallee = componentClass.iteratorOfMethods () ;
                                    while ( fujaba__IterComponentClassMethodsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          callee = (UMLMethod) fujaba__IterComponentClassMethodsCallee.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                           
                                          // bind multiDelegation6: MultiDelegationAnnotation
                                          fujaba__IterCallerAnnotationsMultiDelegation6 = caller.iteratorOfAnnotations () ;
                                          while ( fujaba__IterCallerAnnotationsMultiDelegation6.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterCallerAnnotationsMultiDelegation6.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof MultiDelegationAnnotation ) ;
                                                multiDelegation6 = (MultiDelegationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between multiDelegation6 and caller
                                                JavaSDM.ensure ( multiDelegation6.hasInElements ("caller", caller) ) ;
                                                 
                                                // check To-Many-Link 'elements' between multiDelegation6 and callee
                                                JavaSDM.ensure ( multiDelegation6.hasInElements ("callee", callee) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object compositeClass is really bound
                                                      JavaSDM.ensure ( compositeClass != null ) ;
                                                       
                                                      // check object componentClass is really bound
                                                      JavaSDM.ensure ( componentClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                                       
                                                      // bind composite: CompositeAnnotation
                                                      fujaba__IterComponentClassAnnotationsComposite = componentClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterComponentClassAnnotationsComposite.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterComponentClassAnnotationsComposite.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof CompositeAnnotation ) ;
                                                            composite = (CompositeAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between composite and componentClass
                                                            JavaSDM.ensure ( composite.hasInElements ("component", componentClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between composite and compositeClass
                                                            JavaSDM.ensure ( composite.hasInElements ("composite", compositeClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object compositeClass is really bound
                                                         JavaSDM.ensure ( compositeClass != null ) ;
                                                          
                                                         // check object componentClass is really bound
                                                         JavaSDM.ensure ( componentClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                          
                                                         // create object
                                                         composite = new CompositeAnnotation ( ) ;
                                                          
                                                         // assign statement
                                                         composite.setClassification (1);
                                                          
                                                         // create link
                                                         composite.addToElements ("composite", compositeClass);
                                                          
                                                         // create link
                                                         composite.addToElements ("component", componentClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("caller", caller);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("compositeClass", compositeClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("componentClass", componentClass);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object oneToManyAssociation4 is really bound
                                                         JavaSDM.ensure ( oneToManyAssociation4 != null ) ;
                                                          
                                                         // check object generalization5 is really bound
                                                         JavaSDM.ensure ( generalization5 != null ) ;
                                                          
                                                         // check object multiDelegation6 is really bound
                                                         JavaSDM.ensure ( multiDelegation6 != null ) ;
                                                          
                                                         // check object composite is really bound
                                                         JavaSDM.ensure ( composite != null ) ;
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (oneToManyAssociation4);
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (generalization5);
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (multiDelegation6);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (composite) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object composite is really bound
            JavaSDM.ensure ( composite != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_Generalization", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (composite) ;
   }


   private GFRNAnnotation annotateUsingTrigger_MultiDelegationRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CompositeAnnotation composite = null ;
      Iterator fujaba__IterComponentClassAnnotationsGeneralization8 = null ;
      Iterator fujaba__IterComponentClassAnnotationsOneToManyAssociation7 = null ;
      Iterator fujaba__IterCompositeClassAnnotationsComposite = null ;
      Iterator fujaba__IterMultiDelegation9ElementsCallee = null ;
      Iterator fujaba__IterMultiDelegation9ElementsCaller = null ;
      GeneralizationAnnotation generalization8 = null ;
      MultiDelegationAnnotation multiDelegation9 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation7 = null ;
      UMLClass componentClass = null ;
      UMLClass compositeClass = null ;
      UMLMethod callee = null ;
      UMLMethod caller = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_MultiDelegation", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiDelegationAnnotation ) ;
             
            // explicit type cast
            multiDelegation9 = (MultiDelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterMultiDelegation9ElementsCallee = multiDelegation9.iteratorOfElements ("callee") ;
            while ( fujaba__IterMultiDelegation9ElementsCallee.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiDelegation9ElementsCallee.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  callee = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind componentClass: UMLClass
                  componentClass = callee.getParent () ;
                  JavaSDM.ensure ( componentClass != null ) ;
                   
                  // bind caller: UMLMethod
                  fujaba__IterMultiDelegation9ElementsCaller = multiDelegation9.iteratorOfElements ("caller") ;
                  while ( fujaba__IterMultiDelegation9ElementsCaller.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterMultiDelegation9ElementsCaller.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        caller = (UMLMethod) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                         
                        // bind compositeClass: UMLClass
                        compositeClass = caller.getParent () ;
                        JavaSDM.ensure ( compositeClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(componentClass.equals (compositeClass)) ) ;
                         
                        // bind generalization8: GeneralizationAnnotation
                        fujaba__IterComponentClassAnnotationsGeneralization8 = componentClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterComponentClassAnnotationsGeneralization8.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterComponentClassAnnotationsGeneralization8.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization8 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization8 and componentClass
                              JavaSDM.ensure ( generalization8.hasInElements ("superClass", componentClass) ) ;
                               
                              // check To-Many-Link 'elements' between generalization8 and compositeClass
                              JavaSDM.ensure ( generalization8.hasInElements ("subClass", compositeClass) ) ;
                               
                              // bind oneToManyAssociation7: OneToManyAssociationAnnotation
                              fujaba__IterComponentClassAnnotationsOneToManyAssociation7 = componentClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterComponentClassAnnotationsOneToManyAssociation7.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterComponentClassAnnotationsOneToManyAssociation7.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                                    oneToManyAssociation7 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between oneToManyAssociation7 and componentClass
                                    JavaSDM.ensure ( oneToManyAssociation7.hasInElements ("many", componentClass) ) ;
                                     
                                    // check To-Many-Link 'elements' between oneToManyAssociation7 and compositeClass
                                    JavaSDM.ensure ( oneToManyAssociation7.hasInElements ("one", compositeClass) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object compositeClass is really bound
                                          JavaSDM.ensure ( compositeClass != null ) ;
                                           
                                          // check object componentClass is really bound
                                          JavaSDM.ensure ( componentClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                           
                                          // bind composite: CompositeAnnotation
                                          fujaba__IterCompositeClassAnnotationsComposite = compositeClass.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterCompositeClassAnnotationsComposite.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterCompositeClassAnnotationsComposite.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof CompositeAnnotation ) ;
                                                composite = (CompositeAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between composite and compositeClass
                                                JavaSDM.ensure ( composite.hasInElements ("composite", compositeClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between composite and componentClass
                                                JavaSDM.ensure ( composite.hasInElements ("component", componentClass) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object compositeClass is really bound
                                             JavaSDM.ensure ( compositeClass != null ) ;
                                              
                                             // check object componentClass is really bound
                                             JavaSDM.ensure ( componentClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                              
                                             // check object callee is really bound
                                             JavaSDM.ensure ( callee != null ) ;
                                              
                                             // check object caller is really bound
                                             JavaSDM.ensure ( caller != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                              
                                             // create object
                                             composite = new CompositeAnnotation ( ) ;
                                              
                                             // assign statement
                                             composite.setClassification (1);
                                              
                                             // create link
                                             composite.addToElements ("composite", compositeClass);
                                              
                                             // create link
                                             composite.addToElements ("component", componentClass);
                                              
                                             // create link
                                             composite.addToBoundObjects ("callee", callee);
                                              
                                             // create link
                                             composite.addToBoundObjects ("caller", caller);
                                              
                                             // create link
                                             composite.addToBoundObjects ("compositeClass", compositeClass);
                                              
                                             // create link
                                             composite.addToBoundObjects ("componentClass", componentClass);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object oneToManyAssociation7 is really bound
                                             JavaSDM.ensure ( oneToManyAssociation7 != null ) ;
                                              
                                             // check object generalization8 is really bound
                                             JavaSDM.ensure ( generalization8 != null ) ;
                                              
                                             // check object multiDelegation9 is really bound
                                             JavaSDM.ensure ( multiDelegation9 != null ) ;
                                              
                                             // check object composite is really bound
                                             JavaSDM.ensure ( composite != null ) ;
                                              
                                             // create link
                                             composite.addToAntecedentAnnos (oneToManyAssociation7);
                                              
                                             // create link
                                             composite.addToAntecedentAnnos (generalization8);
                                              
                                             // create link
                                             composite.addToAntecedentAnnos (multiDelegation9);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (composite) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object composite is really bound
            JavaSDM.ensure ( composite != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_MultiDelegation", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (composite) ;
   }


   private GFRNAnnotation annotateUsingTrigger_OneToManyAssociationRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CompositeAnnotation composite = null ;
      Iterator fujaba__IterCallerAnnotationsMultiDelegation3 = null ;
      Iterator fujaba__IterComponentClassAnnotationsComposite = null ;
      Iterator fujaba__IterComponentClassMethodsCallee = null ;
      Iterator fujaba__IterCompositeClassAnnotationsGeneralization2 = null ;
      Iterator fujaba__IterCompositeClassMethodsCaller = null ;
      Iterator fujaba__IterOneToManyAssociation1ElementsComponentClass = null ;
      Iterator fujaba__IterOneToManyAssociation1ElementsCompositeClass = null ;
      GeneralizationAnnotation generalization2 = null ;
      MultiDelegationAnnotation multiDelegation3 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation1 = null ;
      UMLClass componentClass = null ;
      UMLClass compositeClass = null ;
      UMLMethod callee = null ;
      UMLMethod caller = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_OneToManyAssociation", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OneToManyAssociationAnnotation ) ;
             
            // explicit type cast
            oneToManyAssociation1 = (OneToManyAssociationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind compositeClass: UMLClass
            fujaba__IterOneToManyAssociation1ElementsCompositeClass = oneToManyAssociation1.iteratorOfElements ("one") ;
            while ( fujaba__IterOneToManyAssociation1ElementsCompositeClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOneToManyAssociation1ElementsCompositeClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  compositeClass = (UMLClass) fujaba__TmpObject ;
                   
                  // bind componentClass: UMLClass
                  fujaba__IterOneToManyAssociation1ElementsComponentClass = oneToManyAssociation1.iteratorOfElements ("many") ;
                  while ( fujaba__IterOneToManyAssociation1ElementsComponentClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterOneToManyAssociation1ElementsComponentClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        componentClass = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                         
                        // bind caller: UMLMethod
                        fujaba__IterCompositeClassMethodsCaller = compositeClass.iteratorOfMethods () ;
                        while ( fujaba__IterCompositeClassMethodsCaller.hasNext () )
                        {
                           try
                           {
                              caller = (UMLMethod) fujaba__IterCompositeClassMethodsCaller.next () ;
                               
                              // bind generalization2: GeneralizationAnnotation
                              fujaba__IterCompositeClassAnnotationsGeneralization2 = compositeClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterCompositeClassAnnotationsGeneralization2.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCompositeClassAnnotationsGeneralization2.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization2 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization2 and compositeClass
                                    JavaSDM.ensure ( generalization2.hasInElements ("subClass", compositeClass) ) ;
                                     
                                    // check To-Many-Link 'elements' between generalization2 and componentClass
                                    JavaSDM.ensure ( generalization2.hasInElements ("superClass", componentClass) ) ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterComponentClassMethodsCallee = componentClass.iteratorOfMethods () ;
                                    while ( fujaba__IterComponentClassMethodsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          callee = (UMLMethod) fujaba__IterComponentClassMethodsCallee.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                           
                                          // bind multiDelegation3: MultiDelegationAnnotation
                                          fujaba__IterCallerAnnotationsMultiDelegation3 = caller.iteratorOfAnnotations () ;
                                          while ( fujaba__IterCallerAnnotationsMultiDelegation3.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterCallerAnnotationsMultiDelegation3.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof MultiDelegationAnnotation ) ;
                                                multiDelegation3 = (MultiDelegationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between multiDelegation3 and caller
                                                JavaSDM.ensure ( multiDelegation3.hasInElements ("caller", caller) ) ;
                                                 
                                                // check To-Many-Link 'elements' between multiDelegation3 and callee
                                                JavaSDM.ensure ( multiDelegation3.hasInElements ("callee", callee) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object compositeClass is really bound
                                                      JavaSDM.ensure ( compositeClass != null ) ;
                                                       
                                                      // check object componentClass is really bound
                                                      JavaSDM.ensure ( componentClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                                       
                                                      // bind composite: CompositeAnnotation
                                                      fujaba__IterComponentClassAnnotationsComposite = componentClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterComponentClassAnnotationsComposite.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterComponentClassAnnotationsComposite.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof CompositeAnnotation ) ;
                                                            composite = (CompositeAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between composite and componentClass
                                                            JavaSDM.ensure ( composite.hasInElements ("component", componentClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between composite and compositeClass
                                                            JavaSDM.ensure ( composite.hasInElements ("composite", compositeClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object compositeClass is really bound
                                                         JavaSDM.ensure ( compositeClass != null ) ;
                                                          
                                                         // check object componentClass is really bound
                                                         JavaSDM.ensure ( componentClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                          
                                                         // create object
                                                         composite = new CompositeAnnotation ( ) ;
                                                          
                                                         // assign statement
                                                         composite.setClassification (1);
                                                          
                                                         // create link
                                                         composite.addToElements ("composite", compositeClass);
                                                          
                                                         // create link
                                                         composite.addToElements ("component", componentClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("caller", caller);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("compositeClass", compositeClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("componentClass", componentClass);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object oneToManyAssociation1 is really bound
                                                         JavaSDM.ensure ( oneToManyAssociation1 != null ) ;
                                                          
                                                         // check object generalization2 is really bound
                                                         JavaSDM.ensure ( generalization2 != null ) ;
                                                          
                                                         // check object multiDelegation3 is really bound
                                                         JavaSDM.ensure ( multiDelegation3 != null ) ;
                                                          
                                                         // check object composite is really bound
                                                         JavaSDM.ensure ( composite != null ) ;
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (oneToManyAssociation1);
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (generalization2);
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (multiDelegation3);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (composite) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object composite is really bound
            JavaSDM.ensure ( composite != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_OneToManyAssociation", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (composite) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("composite", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("component", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OneToManyAssociationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_OneToManyAssociation", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof MultiDelegationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_MultiDelegation", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterComponentClassMethodsCallee = null ;
      Iterator fujaba__IterCompositeClassMethodsCaller = null ;
      Iterator fujaba__IterGeneralization14ElementsComponentClass = null ;
      Iterator fujaba__IterMultiDelegation15ElementsCallee = null ;
      Iterator fujaba__IterOneToManyAssociation13ElementsComponentClass = null ;
      GeneralizationAnnotation generalization14 = null ;
      MultiDelegationAnnotation multiDelegation15 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation13 = null ;
      UMLClass componentClass = null ;
      UMLClass compositeClass = null ;
      UMLMethod callee = null ;
      UMLMethod caller = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("OneToManyAssociation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            compositeClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (compositeClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (componentClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization14 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind componentClass: UMLClass
            fujaba__IterGeneralization14ElementsComponentClass = generalization14.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization14ElementsComponentClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization14ElementsComponentClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  componentClass = (UMLClass) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (componentClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiDelegationAnnotation ) ;
             
            // explicit type cast
            multiDelegation15 = (MultiDelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterMultiDelegation15ElementsCallee = multiDelegation15.iteratorOfElements ("callee") ;
            while ( fujaba__IterMultiDelegation15ElementsCallee.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiDelegation15ElementsCallee.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  callee = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind componentClass: UMLClass
                  componentClass = callee.getParent () ;
                  JavaSDM.ensure ( componentClass != null ) ;
                   
                  {
                     //  for each flow
                     set.add (componentClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") || annotation.equals ("MultiLevelGeneralization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            compositeClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (compositeClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (componentClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OneToManyAssociationAnnotation ) ;
             
            // explicit type cast
            oneToManyAssociation13 = (OneToManyAssociationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind componentClass: UMLClass
            fujaba__IterOneToManyAssociation13ElementsComponentClass = oneToManyAssociation13.iteratorOfElements ("many") ;
            while ( fujaba__IterOneToManyAssociation13ElementsComponentClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOneToManyAssociation13ElementsComponentClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  componentClass = (UMLClass) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (componentClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiDelegationAnnotation ) ;
             
            // explicit type cast
            multiDelegation15 = (MultiDelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterMultiDelegation15ElementsCallee = multiDelegation15.iteratorOfElements ("callee") ;
            while ( fujaba__IterMultiDelegation15ElementsCallee.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiDelegation15ElementsCallee.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  callee = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind componentClass: UMLClass
                  componentClass = callee.getParent () ;
                  JavaSDM.ensure ( componentClass != null ) ;
                   
                  {
                     //  for each flow
                     set.add (componentClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("MultiDelegation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            compositeClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterCompositeClassMethodsCaller = compositeClass.iteratorOfMethods () ;
            while ( fujaba__IterCompositeClassMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (UMLMethod) fujaba__IterCompositeClassMethodsCaller.next () ;
                   
                  {
                     //  for each flow
                     set.add (caller);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterComponentClassMethodsCallee = componentClass.iteratorOfMethods () ;
            while ( fujaba__IterComponentClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (UMLMethod) fujaba__IterComponentClassMethodsCallee.next () ;
                   
                  {
                     //  for each flow
                     set.add (callee);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OneToManyAssociationAnnotation ) ;
             
            // explicit type cast
            oneToManyAssociation13 = (OneToManyAssociationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind componentClass: UMLClass
            fujaba__IterOneToManyAssociation13ElementsComponentClass = oneToManyAssociation13.iteratorOfElements ("many") ;
            while ( fujaba__IterOneToManyAssociation13ElementsComponentClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOneToManyAssociation13ElementsComponentClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  componentClass = (UMLClass) fujaba__TmpObject ;
                   
                  // bind callee: UMLMethod
                  fujaba__IterComponentClassMethodsCallee = componentClass.iteratorOfMethods () ;
                  while ( fujaba__IterComponentClassMethodsCallee.hasNext () )
                  {
                     try
                     {
                        callee = (UMLMethod) fujaba__IterComponentClassMethodsCallee.next () ;
                         
                        {
                           //  for each flow
                           set.add (callee);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization14 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind componentClass: UMLClass
            fujaba__IterGeneralization14ElementsComponentClass = generalization14.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization14ElementsComponentClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization14ElementsComponentClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  componentClass = (UMLClass) fujaba__TmpObject ;
                   
                  // bind callee: UMLMethod
                  fujaba__IterComponentClassMethodsCallee = componentClass.iteratorOfMethods () ;
                  while ( fujaba__IterComponentClassMethodsCallee.hasNext () )
                  {
                     try
                     {
                        callee = (UMLMethod) fujaba__IterComponentClassMethodsCallee.next () ;
                         
                        {
                           //  for each flow
                           set.add (callee);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
