package de.upb.inferenceengine.engines;

import de.upb.tools.fca.FEmptyIterator;
import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.upb.javaast.methodast.references.UMLDeclarationToIdentifierNodeRef;
import de.upb.javaast.methodast.IdentifierNode;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLParam;
import de.upb.javaast.methodast.PrimaryExpressionNode;
import de.upb.javaast.methodast.RootBlockNode;
import de.upb.javaast.methodast.MethodCallNode;

public class ContainerAccessEngine
extends GFRNEngine
{
   private  ContainerAccessEngine()
   {
   }

   private static ContainerAccessEngine theContainerAccessEngine;

   public static ContainerAccessEngine get()
   {
      if (theContainerAccessEngine == null)
      {
         theContainerAccessEngine = new ContainerAccessEngine ();
      }
      return theContainerAccessEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation containerAccess = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         containerAccess = this.annotateUsingMethodRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( containerAccess != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (containerAccess) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            containerAccess = this.annotateUsingFieldRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( containerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (containerAccess) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               containerAccess = this.annotateUsingParamRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            return (containerAccess) ;
         }
      }
   }


   private GFRNAnnotation annotateUsingFieldRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterRootBlockNode24ToPrimaryExpressionNode21 = null ;
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess = null ;
      Iterator fujaba__IterMethodCallNode20ArgumentsPrimaryExpressionNode23 = null ;
      Iterator fujaba__IterUMLClass18MethodsUMLMethod16 = null ;
      Iterator fujaba__IterUMLMethod16ParamUMLParam19 = null ;
      Iterator fujaba__IterUMLParam19AnnotationsContainerAccess = null ;
      IdentifierNode identifierNode15 = null ;
      IdentifierNode identifierNode22 = null ;
      MethodCallNode methodCallNode20 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode21 = null ;
      PrimaryExpressionNode primaryExpressionNode23 = null ;
      RootBlockNode rootBlockNode24 = null ;
      UMLAttr uMLAttr17 = null ;
      UMLClass containerClass = null ;
      UMLClass uMLClass18 = null ;
      UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef13 = null ;
      UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef14 = null ;
      UMLMethod uMLMethod16 = null ;
      UMLParam uMLParam19 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr17 = (UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind containerClass: UMLClass
            fujaba__TmpObject = uMLAttr17.getAttrType () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
            containerClass = (UMLClass) fujaba__TmpObject ;
             
            // bind uMLClass18: UMLClass
            uMLClass18 = uMLAttr17.getParent () ;
            JavaSDM.ensure ( uMLClass18 != null ) ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(containerClass.equals (uMLClass18)) ) ;
             
            // bind uMLMethod16: UMLMethod
            fujaba__IterUMLClass18MethodsUMLMethod16 = uMLClass18.iteratorOfMethods () ;
            while ( fujaba__IterUMLClass18MethodsUMLMethod16.hasNext () )
            {
               try
               {
                  uMLMethod16 = (UMLMethod) fujaba__IterUMLClass18MethodsUMLMethod16.next () ;
                   
                  // bind rootBlockNode24: RootBlockNode
                  fujaba__TmpObject = uMLMethod16.getASTRootNode () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.RootBlockNode ) ;
                  rootBlockNode24 = (RootBlockNode) fujaba__TmpObject ;
                   
                  // bind uMLParam19: UMLParam
                  fujaba__IterUMLMethod16ParamUMLParam19 = uMLMethod16.iteratorOfParam () ;
                  while ( fujaba__IterUMLMethod16ParamUMLParam19.hasNext () )
                  {
                     try
                     {
                        uMLParam19 = (UMLParam) fujaba__IterUMLMethod16ParamUMLParam19.next () ;
                         
                        // Path search between RootBlockNode and PrimaryExpressionNode
                        // Bind primaryExpressionNode21 : PrimaryExpressionNode
                        fujaba__IterRootBlockNode24ToPrimaryExpressionNode21 = new ASTPathVisitor (rootBlockNode24, PrimaryExpressionNode.class ) ;
                        while ( fujaba__IterRootBlockNode24ToPrimaryExpressionNode21.hasNext () )
                        {
                           try
                           {
                              primaryExpressionNode21 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootBlockNode24ToPrimaryExpressionNode21.next () ;
                               
                              // bind methodCallNode20: MethodCallNode
                              fujaba__TmpObject = primaryExpressionNode21.getNextPrimaryExpression () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                              methodCallNode20 = (MethodCallNode) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(primaryExpressionNode21.equals (methodCallNode20)) ) ;
                               
                              // bind identifierNode22: IdentifierNode
                              identifierNode22 = primaryExpressionNode21.getIdentifier () ;
                              JavaSDM.ensure ( identifierNode22 != null ) ;
                               
                              // bind uMLDeclarationToIdentifierNodeRef13: UMLDeclarationToIdentifierNodeRef
                              uMLDeclarationToIdentifierNodeRef13 = identifierNode22.getUmlDeclarationRef () ;
                              JavaSDM.ensure ( uMLDeclarationToIdentifierNodeRef13 != null ) ;
                               
                              // check To-One-Link 'element' between uMLDeclarationToIdentifierNodeRef13 and uMLAttr17
                              JavaSDM.ensure ( (uMLDeclarationToIdentifierNodeRef13.getElement () != null) && uMLDeclarationToIdentifierNodeRef13.getElement ().equals (uMLAttr17) ) ;
                               
                              // bind primaryExpressionNode23: PrimaryExpressionNode
                              fujaba__IterMethodCallNode20ArgumentsPrimaryExpressionNode23 = methodCallNode20.iteratorOfArguments () ;
                              while ( fujaba__IterMethodCallNode20ArgumentsPrimaryExpressionNode23.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterMethodCallNode20ArgumentsPrimaryExpressionNode23.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                                    primaryExpressionNode23 = (PrimaryExpressionNode) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(methodCallNode20.equals (primaryExpressionNode23)) && !(primaryExpressionNode21.equals (primaryExpressionNode23)) ) ;
                                     
                                    // bind identifierNode15: IdentifierNode
                                    identifierNode15 = primaryExpressionNode23.getIdentifier () ;
                                    JavaSDM.ensure ( identifierNode15 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(identifierNode22.equals (identifierNode15)) ) ;
                                     
                                    // bind uMLDeclarationToIdentifierNodeRef14: UMLDeclarationToIdentifierNodeRef
                                    uMLDeclarationToIdentifierNodeRef14 = identifierNode15.getUmlDeclarationRef () ;
                                    JavaSDM.ensure ( uMLDeclarationToIdentifierNodeRef14 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLDeclarationToIdentifierNodeRef13.equals (uMLDeclarationToIdentifierNodeRef14)) ) ;
                                     
                                    // check To-One-Link 'element' between uMLDeclarationToIdentifierNodeRef14 and uMLParam19
                                    JavaSDM.ensure ( (uMLDeclarationToIdentifierNodeRef14.getElement () != null) && uMLDeclarationToIdentifierNodeRef14.getElement ().equals (uMLParam19) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( de.upb.assocdetection.AssocDetector.isContainerClass(containerClass.getName()) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLMethod16 is really bound
                                          JavaSDM.ensure ( uMLMethod16 != null ) ;
                                           
                                          // check object uMLParam19 is really bound
                                          JavaSDM.ensure ( uMLParam19 != null ) ;
                                           
                                          // check object uMLAttr17 is really bound
                                          JavaSDM.ensure ( uMLAttr17 != null ) ;
                                           
                                          // bind containerAccess: ContainerAccessAnnotation
                                          fujaba__IterUMLParam19AnnotationsContainerAccess = uMLParam19.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterUMLParam19AnnotationsContainerAccess.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLParam19AnnotationsContainerAccess.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                                                containerAccess = (ContainerAccessAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between containerAccess and uMLParam19
                                                JavaSDM.ensure ( containerAccess.hasInElements ("param", uMLParam19) ) ;
                                                 
                                                // check To-Many-Link 'elements' between containerAccess and uMLMethod16
                                                JavaSDM.ensure ( containerAccess.hasInElements ("method", uMLMethod16) ) ;
                                                 
                                                // check To-Many-Link 'elements' between containerAccess and uMLAttr17
                                                JavaSDM.ensure ( containerAccess.hasInElements ("field", uMLAttr17) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLMethod16 is really bound
                                             JavaSDM.ensure ( uMLMethod16 != null ) ;
                                              
                                             // check object uMLParam19 is really bound
                                             JavaSDM.ensure ( uMLParam19 != null ) ;
                                              
                                             // check object uMLAttr17 is really bound
                                             JavaSDM.ensure ( uMLAttr17 != null ) ;
                                              
                                             // check object containerClass is really bound
                                             JavaSDM.ensure ( containerClass != null ) ;
                                              
                                             // create object
                                             containerAccess = new ContainerAccessAnnotation ( ) ;
                                              
                                             // assign statement
                                             containerAccess.setClassification (0);
                                              
                                             // create link
                                             containerAccess.addToElements ("method", uMLMethod16);
                                              
                                             // create link
                                             containerAccess.addToElements ("param", uMLParam19);
                                              
                                             // create link
                                             containerAccess.addToElements ("field", uMLAttr17);
                                              
                                             // create link
                                             containerAccess.addToBoundObjects ("containerClass", containerClass);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (containerAccess) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object containerAccess is really bound
            JavaSDM.ensure ( containerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (containerAccess) ;
   }


   private GFRNAnnotation annotateUsingMethodRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterRootBlockNode12ToPrimaryExpressionNode9 = null ;
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess = null ;
      Iterator fujaba__IterMethodCallNode8ArgumentsPrimaryExpressionNode11 = null ;
      Iterator fujaba__IterUMLAttr5AnnotationsContainerAccess = null ;
      Iterator fujaba__IterUMLClass6AttrsUMLAttr5 = null ;
      Iterator fujaba__IterUMLMethod4ParamUMLParam7 = null ;
      IdentifierNode identifierNode10 = null ;
      IdentifierNode identifierNode3 = null ;
      MethodCallNode methodCallNode8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      PrimaryExpressionNode primaryExpressionNode11 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode9 = null ;
      RootBlockNode rootBlockNode12 = null ;
      UMLAttr uMLAttr5 = null ;
      UMLClass containerClass = null ;
      UMLClass uMLClass6 = null ;
      UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef1 = null ;
      UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef2 = null ;
      UMLMethod uMLMethod4 = null ;
      UMLParam uMLParam7 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            uMLMethod4 = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind rootBlockNode12: RootBlockNode
            fujaba__TmpObject = uMLMethod4.getASTRootNode () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.RootBlockNode ) ;
            rootBlockNode12 = (RootBlockNode) fujaba__TmpObject ;
             
            // bind uMLClass6: UMLClass
            uMLClass6 = uMLMethod4.getParent () ;
            JavaSDM.ensure ( uMLClass6 != null ) ;
             
            // bind uMLParam7: UMLParam
            fujaba__IterUMLMethod4ParamUMLParam7 = uMLMethod4.iteratorOfParam () ;
            while ( fujaba__IterUMLMethod4ParamUMLParam7.hasNext () )
            {
               try
               {
                  uMLParam7 = (UMLParam) fujaba__IterUMLMethod4ParamUMLParam7.next () ;
                   
                  // bind uMLAttr5: UMLAttr
                  fujaba__IterUMLClass6AttrsUMLAttr5 = uMLClass6.iteratorOfAttrs () ;
                  while ( fujaba__IterUMLClass6AttrsUMLAttr5.hasNext () )
                  {
                     try
                     {
                        uMLAttr5 = (UMLAttr) fujaba__IterUMLClass6AttrsUMLAttr5.next () ;
                         
                        // bind containerClass: UMLClass
                        fujaba__TmpObject = uMLAttr5.getAttrType () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        containerClass = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLClass6.equals (containerClass)) ) ;
                         
                        // Path search between RootBlockNode and PrimaryExpressionNode
                        // Bind primaryExpressionNode9 : PrimaryExpressionNode
                        fujaba__IterRootBlockNode12ToPrimaryExpressionNode9 = new ASTPathVisitor (rootBlockNode12, PrimaryExpressionNode.class ) ;
                        while ( fujaba__IterRootBlockNode12ToPrimaryExpressionNode9.hasNext () )
                        {
                           try
                           {
                              primaryExpressionNode9 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootBlockNode12ToPrimaryExpressionNode9.next () ;
                               
                              // bind identifierNode10: IdentifierNode
                              identifierNode10 = primaryExpressionNode9.getIdentifier () ;
                              JavaSDM.ensure ( identifierNode10 != null ) ;
                               
                              // bind methodCallNode8: MethodCallNode
                              fujaba__TmpObject = primaryExpressionNode9.getNextPrimaryExpression () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                              methodCallNode8 = (MethodCallNode) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(primaryExpressionNode9.equals (methodCallNode8)) ) ;
                               
                              // bind uMLDeclarationToIdentifierNodeRef1: UMLDeclarationToIdentifierNodeRef
                              uMLDeclarationToIdentifierNodeRef1 = identifierNode10.getUmlDeclarationRef () ;
                              JavaSDM.ensure ( uMLDeclarationToIdentifierNodeRef1 != null ) ;
                               
                              // check To-One-Link 'element' between uMLDeclarationToIdentifierNodeRef1 and uMLAttr5
                              JavaSDM.ensure ( (uMLDeclarationToIdentifierNodeRef1.getElement () != null) && uMLDeclarationToIdentifierNodeRef1.getElement ().equals (uMLAttr5) ) ;
                               
                              // bind primaryExpressionNode11: PrimaryExpressionNode
                              fujaba__IterMethodCallNode8ArgumentsPrimaryExpressionNode11 = methodCallNode8.iteratorOfArguments () ;
                              while ( fujaba__IterMethodCallNode8ArgumentsPrimaryExpressionNode11.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterMethodCallNode8ArgumentsPrimaryExpressionNode11.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                                    primaryExpressionNode11 = (PrimaryExpressionNode) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(primaryExpressionNode9.equals (primaryExpressionNode11)) && !(methodCallNode8.equals (primaryExpressionNode11)) ) ;
                                     
                                    // bind identifierNode3: IdentifierNode
                                    identifierNode3 = primaryExpressionNode11.getIdentifier () ;
                                    JavaSDM.ensure ( identifierNode3 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(identifierNode10.equals (identifierNode3)) ) ;
                                     
                                    // bind uMLDeclarationToIdentifierNodeRef2: UMLDeclarationToIdentifierNodeRef
                                    uMLDeclarationToIdentifierNodeRef2 = identifierNode3.getUmlDeclarationRef () ;
                                    JavaSDM.ensure ( uMLDeclarationToIdentifierNodeRef2 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLDeclarationToIdentifierNodeRef1.equals (uMLDeclarationToIdentifierNodeRef2)) ) ;
                                     
                                    // check To-One-Link 'element' between uMLDeclarationToIdentifierNodeRef2 and uMLParam7
                                    JavaSDM.ensure ( (uMLDeclarationToIdentifierNodeRef2.getElement () != null) && uMLDeclarationToIdentifierNodeRef2.getElement ().equals (uMLParam7) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( de.upb.assocdetection.AssocDetector.isContainerClass(containerClass.getName()) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLMethod4 is really bound
                                          JavaSDM.ensure ( uMLMethod4 != null ) ;
                                           
                                          // check object uMLParam7 is really bound
                                          JavaSDM.ensure ( uMLParam7 != null ) ;
                                           
                                          // check object uMLAttr5 is really bound
                                          JavaSDM.ensure ( uMLAttr5 != null ) ;
                                           
                                          // bind containerAccess: ContainerAccessAnnotation
                                          fujaba__IterUMLAttr5AnnotationsContainerAccess = uMLAttr5.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterUMLAttr5AnnotationsContainerAccess.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLAttr5AnnotationsContainerAccess.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                                                containerAccess = (ContainerAccessAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between containerAccess and uMLAttr5
                                                JavaSDM.ensure ( containerAccess.hasInElements ("field", uMLAttr5) ) ;
                                                 
                                                // check To-Many-Link 'elements' between containerAccess and uMLMethod4
                                                JavaSDM.ensure ( containerAccess.hasInElements ("method", uMLMethod4) ) ;
                                                 
                                                // check To-Many-Link 'elements' between containerAccess and uMLParam7
                                                JavaSDM.ensure ( containerAccess.hasInElements ("param", uMLParam7) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLMethod4 is really bound
                                             JavaSDM.ensure ( uMLMethod4 != null ) ;
                                              
                                             // check object uMLParam7 is really bound
                                             JavaSDM.ensure ( uMLParam7 != null ) ;
                                              
                                             // check object uMLAttr5 is really bound
                                             JavaSDM.ensure ( uMLAttr5 != null ) ;
                                              
                                             // check object containerClass is really bound
                                             JavaSDM.ensure ( containerClass != null ) ;
                                              
                                             // create object
                                             containerAccess = new ContainerAccessAnnotation ( ) ;
                                              
                                             // assign statement
                                             containerAccess.setClassification (0);
                                              
                                             // create link
                                             containerAccess.addToElements ("method", uMLMethod4);
                                              
                                             // create link
                                             containerAccess.addToElements ("param", uMLParam7);
                                              
                                             // create link
                                             containerAccess.addToElements ("field", uMLAttr5);
                                              
                                             // create link
                                             containerAccess.addToBoundObjects ("containerClass", containerClass);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (containerAccess) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object containerAccess is really bound
            JavaSDM.ensure ( containerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (containerAccess) ;
   }


   private GFRNAnnotation annotateUsingParamRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterRootBlockNode36ToPrimaryExpressionNode33 = null ;
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess = null ;
      Iterator fujaba__IterMethodCallNode32ArgumentsPrimaryExpressionNode35 = null ;
      Iterator fujaba__IterUMLClass30AttrsUMLAttr29 = null ;
      Iterator fujaba__IterUMLParam31AnnotationsContainerAccess = null ;
      IdentifierNode identifierNode27 = null ;
      IdentifierNode identifierNode34 = null ;
      MethodCallNode methodCallNode32 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode33 = null ;
      PrimaryExpressionNode primaryExpressionNode35 = null ;
      RootBlockNode rootBlockNode36 = null ;
      UMLAttr uMLAttr29 = null ;
      UMLClass containerClass = null ;
      UMLClass uMLClass30 = null ;
      UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef25 = null ;
      UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef26 = null ;
      UMLMethod uMLMethod28 = null ;
      UMLParam uMLParam31 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            uMLParam31 = (UMLParam) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod28: UMLMethod
            uMLMethod28 = uMLParam31.getRevParam () ;
            JavaSDM.ensure ( uMLMethod28 != null ) ;
             
            // bind rootBlockNode36: RootBlockNode
            fujaba__TmpObject = uMLMethod28.getASTRootNode () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.RootBlockNode ) ;
            rootBlockNode36 = (RootBlockNode) fujaba__TmpObject ;
             
            // bind uMLClass30: UMLClass
            uMLClass30 = uMLMethod28.getParent () ;
            JavaSDM.ensure ( uMLClass30 != null ) ;
             
            // bind uMLAttr29: UMLAttr
            fujaba__IterUMLClass30AttrsUMLAttr29 = uMLClass30.iteratorOfAttrs () ;
            while ( fujaba__IterUMLClass30AttrsUMLAttr29.hasNext () )
            {
               try
               {
                  uMLAttr29 = (UMLAttr) fujaba__IterUMLClass30AttrsUMLAttr29.next () ;
                   
                  // bind containerClass: UMLClass
                  fujaba__TmpObject = uMLAttr29.getAttrType () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  containerClass = (UMLClass) fujaba__TmpObject ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(uMLClass30.equals (containerClass)) ) ;
                   
                  // Path search between RootBlockNode and PrimaryExpressionNode
                  // Bind primaryExpressionNode33 : PrimaryExpressionNode
                  fujaba__IterRootBlockNode36ToPrimaryExpressionNode33 = new ASTPathVisitor (rootBlockNode36, PrimaryExpressionNode.class ) ;
                  while ( fujaba__IterRootBlockNode36ToPrimaryExpressionNode33.hasNext () )
                  {
                     try
                     {
                        primaryExpressionNode33 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootBlockNode36ToPrimaryExpressionNode33.next () ;
                         
                        // bind methodCallNode32: MethodCallNode
                        fujaba__TmpObject = primaryExpressionNode33.getNextPrimaryExpression () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                        methodCallNode32 = (MethodCallNode) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(primaryExpressionNode33.equals (methodCallNode32)) ) ;
                         
                        // bind identifierNode34: IdentifierNode
                        identifierNode34 = primaryExpressionNode33.getIdentifier () ;
                        JavaSDM.ensure ( identifierNode34 != null ) ;
                         
                        // bind uMLDeclarationToIdentifierNodeRef25: UMLDeclarationToIdentifierNodeRef
                        uMLDeclarationToIdentifierNodeRef25 = identifierNode34.getUmlDeclarationRef () ;
                        JavaSDM.ensure ( uMLDeclarationToIdentifierNodeRef25 != null ) ;
                         
                        // check To-One-Link 'element' between uMLDeclarationToIdentifierNodeRef25 and uMLAttr29
                        JavaSDM.ensure ( (uMLDeclarationToIdentifierNodeRef25.getElement () != null) && uMLDeclarationToIdentifierNodeRef25.getElement ().equals (uMLAttr29) ) ;
                         
                        // bind primaryExpressionNode35: PrimaryExpressionNode
                        fujaba__IterMethodCallNode32ArgumentsPrimaryExpressionNode35 = methodCallNode32.iteratorOfArguments () ;
                        while ( fujaba__IterMethodCallNode32ArgumentsPrimaryExpressionNode35.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMethodCallNode32ArgumentsPrimaryExpressionNode35.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                              primaryExpressionNode35 = (PrimaryExpressionNode) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(methodCallNode32.equals (primaryExpressionNode35)) && !(primaryExpressionNode33.equals (primaryExpressionNode35)) ) ;
                               
                              // bind identifierNode27: IdentifierNode
                              identifierNode27 = primaryExpressionNode35.getIdentifier () ;
                              JavaSDM.ensure ( identifierNode27 != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(identifierNode34.equals (identifierNode27)) ) ;
                               
                              // bind uMLDeclarationToIdentifierNodeRef26: UMLDeclarationToIdentifierNodeRef
                              uMLDeclarationToIdentifierNodeRef26 = identifierNode27.getUmlDeclarationRef () ;
                              JavaSDM.ensure ( uMLDeclarationToIdentifierNodeRef26 != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLDeclarationToIdentifierNodeRef25.equals (uMLDeclarationToIdentifierNodeRef26)) ) ;
                               
                              // check To-One-Link 'element' between uMLDeclarationToIdentifierNodeRef26 and uMLParam31
                              JavaSDM.ensure ( (uMLDeclarationToIdentifierNodeRef26.getElement () != null) && uMLDeclarationToIdentifierNodeRef26.getElement ().equals (uMLParam31) ) ;
                               
                              // constraint
                              JavaSDM.ensure ( de.upb.assocdetection.AssocDetector.isContainerClass(containerClass.getName()) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object uMLMethod28 is really bound
                                    JavaSDM.ensure ( uMLMethod28 != null ) ;
                                     
                                    // check object uMLParam31 is really bound
                                    JavaSDM.ensure ( uMLParam31 != null ) ;
                                     
                                    // check object uMLAttr29 is really bound
                                    JavaSDM.ensure ( uMLAttr29 != null ) ;
                                     
                                    // bind containerAccess: ContainerAccessAnnotation
                                    fujaba__IterUMLParam31AnnotationsContainerAccess = uMLParam31.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterUMLParam31AnnotationsContainerAccess.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterUMLParam31AnnotationsContainerAccess.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                                          containerAccess = (ContainerAccessAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between containerAccess and uMLParam31
                                          JavaSDM.ensure ( containerAccess.hasInElements ("param", uMLParam31) ) ;
                                           
                                          // check To-Many-Link 'elements' between containerAccess and uMLMethod28
                                          JavaSDM.ensure ( containerAccess.hasInElements ("method", uMLMethod28) ) ;
                                           
                                          // check To-Many-Link 'elements' between containerAccess and uMLAttr29
                                          JavaSDM.ensure ( containerAccess.hasInElements ("field", uMLAttr29) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object uMLMethod28 is really bound
                                       JavaSDM.ensure ( uMLMethod28 != null ) ;
                                        
                                       // check object uMLParam31 is really bound
                                       JavaSDM.ensure ( uMLParam31 != null ) ;
                                        
                                       // check object uMLAttr29 is really bound
                                       JavaSDM.ensure ( uMLAttr29 != null ) ;
                                        
                                       // check object containerClass is really bound
                                       JavaSDM.ensure ( containerClass != null ) ;
                                        
                                       // create object
                                       containerAccess = new ContainerAccessAnnotation ( ) ;
                                        
                                       // assign statement
                                       containerAccess.setClassification (0);
                                        
                                       // create link
                                       containerAccess.addToElements ("method", uMLMethod28);
                                        
                                       // create link
                                       containerAccess.addToElements ("param", uMLParam31);
                                        
                                       // create link
                                       containerAccess.addToElements ("field", uMLAttr29);
                                        
                                       // create link
                                       containerAccess.addToBoundObjects ("containerClass", containerClass);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (containerAccess) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object containerAccess is really bound
            JavaSDM.ensure ( containerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("param", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (containerAccess) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLParam )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      return (FEmptyIterator.get()) ;
   }


}
