package de.upb.inferenceengine.engines;

import de.upb.tools.fca.FEmptyIterator;
import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.upb.javaast.methodast.IdentifierNode;
import de.uni_paderborn.fujaba.uml.ASTRootNode;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.upb.javaast.methodast.AllocationNode;

public class CreateMethodEngine
extends GFRNEngine
{
   private  CreateMethodEngine()
   {
   }

   private static CreateMethodEngine theCreateMethodEngine;

   public static CreateMethodEngine get()
   {
      if (theCreateMethodEngine == null)
      {
         theCreateMethodEngine = new CreateMethodEngine ();
      }
      return theCreateMethodEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation createMethod = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         createMethod = this.annotateUsingMethodRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( createMethod != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (createMethod) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            createMethod = this.annotateUsingCreatesRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         return (createMethod) ;
      }
   }


   private GFRNAnnotation annotateUsingCreatesRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterRootToAllocationNode2 = null ;
      ASTRootNode root = null ;
      de.upb.javaast.methodast.AllocationNode allocationNode2 = null ;
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod = null ;
      Iterator fujaba__IterReturnTypeAnnotationsCreateMethod = null ;
      Iterator fujaba__IterReturnTypeRevResultTypeMethodCreate = null ;
      IdentifierNode constructor = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass returnType = null ;
      UMLMethod methodCreate = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("creates", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            returnType = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind methodCreate: UMLMethod
            fujaba__IterReturnTypeRevResultTypeMethodCreate = returnType.iteratorOfRevResultType () ;
            while ( fujaba__IterReturnTypeRevResultTypeMethodCreate.hasNext () )
            {
               try
               {
                  methodCreate = (UMLMethod) fujaba__IterReturnTypeRevResultTypeMethodCreate.next () ;
                   
                  // bind root: ASTRootNode
                  root = methodCreate.getASTRootNode () ;
                  JavaSDM.ensure ( root != null ) ;
                   
                  // Path search between ASTRootNode and AllocationNode
                  // Bind allocationNode2 : AllocationNode
                  fujaba__IterRootToAllocationNode2 = new ASTPathVisitor (root, AllocationNode.class ) ;
                  while ( fujaba__IterRootToAllocationNode2.hasNext () )
                  {
                     try
                     {
                        allocationNode2 = (de.upb.javaast.methodast.AllocationNode) fujaba__IterRootToAllocationNode2.next () ;
                         
                        // bind constructor: IdentifierNode
                        constructor = allocationNode2.getIdentifier () ;
                        JavaSDM.ensure ( constructor != null ) ;
                         
                        // constraint
                        JavaSDM.ensure ( constructor.getName().equals(returnType.getName()) ) ;
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object methodCreate is really bound
                              JavaSDM.ensure ( methodCreate != null ) ;
                               
                              // check object returnType is really bound
                              JavaSDM.ensure ( returnType != null ) ;
                               
                              // bind createMethod: CreateMethodAnnotation
                              fujaba__IterReturnTypeAnnotationsCreateMethod = returnType.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterReturnTypeAnnotationsCreateMethod.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterReturnTypeAnnotationsCreateMethod.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                                    createMethod = (CreateMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between createMethod and returnType
                                    JavaSDM.ensure ( createMethod.hasInElements ("creates", returnType) ) ;
                                     
                                    // check To-Many-Link 'elements' between createMethod and methodCreate
                                    JavaSDM.ensure ( createMethod.hasInElements ("method", methodCreate) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object methodCreate is really bound
                                 JavaSDM.ensure ( methodCreate != null ) ;
                                  
                                 // check object returnType is really bound
                                 JavaSDM.ensure ( returnType != null ) ;
                                  
                                 // check object constructor is really bound
                                 JavaSDM.ensure ( constructor != null ) ;
                                  
                                 // check object root is really bound
                                 JavaSDM.ensure ( root != null ) ;
                                  
                                 // create object
                                 createMethod = new CreateMethodAnnotation ( ) ;
                                  
                                 // assign statement
                                 createMethod.setClassification (0);
                                  
                                 // create link
                                 createMethod.addToElements ("method", methodCreate);
                                  
                                 // create link
                                 createMethod.addToElements ("creates", returnType);
                                  
                                 // create link
                                 createMethod.addToBoundObjects ("methodCreate", methodCreate);
                                  
                                 // create link
                                 createMethod.addToBoundObjects ("constructor", constructor);
                                  
                                 // create link
                                 createMethod.addToBoundObjects ("root", root);
                                  
                                 // create link
                                 createMethod.addToBoundObjects ("returnType", returnType);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (createMethod) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object createMethod is really bound
            JavaSDM.ensure ( createMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("creates", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (createMethod) ;
   }


   private GFRNAnnotation annotateUsingMethodRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterRootToAllocationNode1 = null ;
      ASTRootNode root = null ;
      de.upb.javaast.methodast.AllocationNode allocationNode1 = null ;
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod = null ;
      Iterator fujaba__IterReturnTypeAnnotationsCreateMethod = null ;
      IdentifierNode constructor = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass returnType = null ;
      UMLMethod methodCreate = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            methodCreate = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind returnType: UMLClass
            fujaba__TmpObject = methodCreate.getResultType () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
            returnType = (UMLClass) fujaba__TmpObject ;
             
            // bind root: ASTRootNode
            root = methodCreate.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // Path search between ASTRootNode and AllocationNode
            // Bind allocationNode1 : AllocationNode
            fujaba__IterRootToAllocationNode1 = new ASTPathVisitor (root, AllocationNode.class ) ;
            while ( fujaba__IterRootToAllocationNode1.hasNext () )
            {
               try
               {
                  allocationNode1 = (de.upb.javaast.methodast.AllocationNode) fujaba__IterRootToAllocationNode1.next () ;
                   
                  // bind constructor: IdentifierNode
                  constructor = allocationNode1.getIdentifier () ;
                  JavaSDM.ensure ( constructor != null ) ;
                   
                  // constraint
                  JavaSDM.ensure ( constructor.getName().equals(returnType.getName()) ) ;
                   
                  {
                     //  for each flow
                     try
                     {
                        fujaba__Success = false ;
                         
                        // check object methodCreate is really bound
                        JavaSDM.ensure ( methodCreate != null ) ;
                         
                        // check object returnType is really bound
                        JavaSDM.ensure ( returnType != null ) ;
                         
                        // bind createMethod: CreateMethodAnnotation
                        fujaba__IterReturnTypeAnnotationsCreateMethod = returnType.iteratorOfAnnotations () ;
                        while ( !(fujaba__Success) && fujaba__IterReturnTypeAnnotationsCreateMethod.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReturnTypeAnnotationsCreateMethod.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                              createMethod = (CreateMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between createMethod and returnType
                              JavaSDM.ensure ( createMethod.hasInElements ("creates", returnType) ) ;
                               
                              // check To-Many-Link 'elements' between createMethod and methodCreate
                              JavaSDM.ensure ( createMethod.hasInElements ("method", methodCreate) ) ;
                               
                              fujaba__Success = true ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false ;
                     }
                      
                     if ( !(fujaba__Success) )
                     {
                        try
                        {
                           fujaba__Success = false ;
                            
                           // check object methodCreate is really bound
                           JavaSDM.ensure ( methodCreate != null ) ;
                            
                           // check object returnType is really bound
                           JavaSDM.ensure ( returnType != null ) ;
                            
                           // check object constructor is really bound
                           JavaSDM.ensure ( constructor != null ) ;
                            
                           // check object root is really bound
                           JavaSDM.ensure ( root != null ) ;
                            
                           // create object
                           createMethod = new CreateMethodAnnotation ( ) ;
                            
                           // assign statement
                           createMethod.setClassification (0);
                            
                           // create link
                           createMethod.addToElements ("method", methodCreate);
                            
                           // create link
                           createMethod.addToElements ("creates", returnType);
                            
                           // create link
                           createMethod.addToBoundObjects ("methodCreate", methodCreate);
                            
                           // create link
                           createMethod.addToBoundObjects ("constructor", constructor);
                            
                           // create link
                           createMethod.addToBoundObjects ("root", root);
                            
                           // create link
                           createMethod.addToBoundObjects ("returnType", returnType);
                            
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        try
                        {
                           fujaba__Success = false ;
                            
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        return (createMethod) ;
                     }
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object createMethod is really bound
            JavaSDM.ensure ( createMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (createMethod) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("creates", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      return (FEmptyIterator.get()) ;
   }


}
