package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class FlyweightEngine
extends GFRNEngine
{
   private  FlyweightEngine()
   {
   }

   private static FlyweightEngine theFlyweightEngine;

   public static FlyweightEngine get()
   {
      if (theFlyweightEngine == null)
      {
         theFlyweightEngine = new FlyweightEngine ();
      }
      return theFlyweightEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation flyweight = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         flyweight = this.annotateUsingTrigger_CreateMethodRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( flyweight != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (flyweight) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            flyweight = this.annotateUsingFactoryRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( flyweight != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (flyweight) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               flyweight = this.annotateUsingFlyweightRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            try
            {
               fujaba__Success = false ;
                
               // constraint
               JavaSDM.ensure ( flyweight != null ) ;
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            if ( fujaba__Success )
            {
               return (flyweight) ;
            }
            else
            {
               try
               {
                  fujaba__Success = false ;
                   
                  // collabStatBegin 1 is empty !
                  flyweight = this.annotateUsingTrigger_OneToManyAssociationRole(asgElement);
                   
                  // collabStatEnd
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               return (flyweight) ;
            }
         }
      }
   }


   private GFRNAnnotation annotateUsingFactoryRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod6 = null ;
      Iterator fujaba__IterOneToManyAssociation9ElementsUMLClass8 = null ;
      Iterator fujaba__IterUMLClass7AnnotationsOneToManyAssociation9 = null ;
      Iterator fujaba__IterUMLClass7MethodsUMLMethod10 = null ;
      Iterator fujaba__IterUMLClass8AnnotationsFlyweight = null ;
      Iterator fujaba__IterUMLMethod10AnnotationsCreateMethod6 = null ;
      FlyweightAnnotation flyweight = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation9 = null ;
      UMLClass uMLClass7 = null ;
      UMLClass uMLClass8 = null ;
      UMLMethod uMLMethod10 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("factory", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass7 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod10: UMLMethod
            fujaba__IterUMLClass7MethodsUMLMethod10 = uMLClass7.iteratorOfMethods () ;
            while ( fujaba__IterUMLClass7MethodsUMLMethod10.hasNext () )
            {
               try
               {
                  uMLMethod10 = (UMLMethod) fujaba__IterUMLClass7MethodsUMLMethod10.next () ;
                   
                  // bind oneToManyAssociation9: OneToManyAssociationAnnotation
                  fujaba__IterUMLClass7AnnotationsOneToManyAssociation9 = uMLClass7.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLClass7AnnotationsOneToManyAssociation9.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLClass7AnnotationsOneToManyAssociation9.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                        oneToManyAssociation9 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between oneToManyAssociation9 and uMLClass7
                        JavaSDM.ensure ( oneToManyAssociation9.hasInElements ("one", uMLClass7) ) ;
                         
                        // bind createMethod6: CreateMethodAnnotation
                        fujaba__IterUMLMethod10AnnotationsCreateMethod6 = uMLMethod10.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod10AnnotationsCreateMethod6.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod10AnnotationsCreateMethod6.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                              createMethod6 = (CreateMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between createMethod6 and uMLMethod10
                              JavaSDM.ensure ( createMethod6.hasInElements ("method", uMLMethod10) ) ;
                               
                              // bind uMLClass8: UMLClass
                              fujaba__IterOneToManyAssociation9ElementsUMLClass8 = oneToManyAssociation9.iteratorOfElements ("many") ;
                              while ( fujaba__IterOneToManyAssociation9ElementsUMLClass8.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterOneToManyAssociation9ElementsUMLClass8.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    uMLClass8 = (UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLClass7.equals (uMLClass8)) ) ;
                                     
                                    // check To-Many-Link 'elements' between createMethod6 and uMLClass8
                                    JavaSDM.ensure ( createMethod6.hasInElements ("creates", uMLClass8) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLClass7 is really bound
                                          JavaSDM.ensure ( uMLClass7 != null ) ;
                                           
                                          // check object uMLClass8 is really bound
                                          JavaSDM.ensure ( uMLClass8 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLClass7.equals (uMLClass8)) ) ;
                                           
                                          // bind flyweight: FlyweightAnnotation
                                          fujaba__IterUMLClass8AnnotationsFlyweight = uMLClass8.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterUMLClass8AnnotationsFlyweight.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLClass8AnnotationsFlyweight.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof FlyweightAnnotation ) ;
                                                flyweight = (FlyweightAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between flyweight and uMLClass8
                                                JavaSDM.ensure ( flyweight.hasInElements ("flyweight", uMLClass8) ) ;
                                                 
                                                // check To-Many-Link 'elements' between flyweight and uMLClass7
                                                JavaSDM.ensure ( flyweight.hasInElements ("factory", uMLClass7) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLClass7 is really bound
                                             JavaSDM.ensure ( uMLClass7 != null ) ;
                                              
                                             // check object uMLClass8 is really bound
                                             JavaSDM.ensure ( uMLClass8 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(uMLClass7.equals (uMLClass8)) ) ;
                                              
                                             // create object
                                             flyweight = new FlyweightAnnotation ( ) ;
                                              
                                             // assign statement
                                             flyweight.setClassification (1);
                                              
                                             // create link
                                             flyweight.addToElements ("factory", uMLClass7);
                                              
                                             // create link
                                             flyweight.addToElements ("flyweight", uMLClass8);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object createMethod6 is really bound
                                             JavaSDM.ensure ( createMethod6 != null ) ;
                                              
                                             // check object oneToManyAssociation9 is really bound
                                             JavaSDM.ensure ( oneToManyAssociation9 != null ) ;
                                              
                                             // check object flyweight is really bound
                                             JavaSDM.ensure ( flyweight != null ) ;
                                              
                                             // create link
                                             flyweight.addToAntecedentAnnos (createMethod6);
                                              
                                             // create link
                                             flyweight.addToAntecedentAnnos (oneToManyAssociation9);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (flyweight) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object flyweight is really bound
            JavaSDM.ensure ( flyweight != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("factory", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (flyweight) ;
   }


   private GFRNAnnotation annotateUsingFlyweightRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod11 = null ;
      Iterator fujaba__IterCreateMethod11ElementsUMLMethod15 = null ;
      Iterator fujaba__IterOneToManyAssociation14ElementsUMLClass12 = null ;
      Iterator fujaba__IterUMLClass12AnnotationsFlyweight = null ;
      Iterator fujaba__IterUMLClass13AnnotationsCreateMethod11 = null ;
      Iterator fujaba__IterUMLClass13AnnotationsOneToManyAssociation14 = null ;
      FlyweightAnnotation flyweight = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation14 = null ;
      UMLClass uMLClass12 = null ;
      UMLClass uMLClass13 = null ;
      UMLMethod uMLMethod15 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("flyweight", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass13 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind oneToManyAssociation14: OneToManyAssociationAnnotation
            fujaba__IterUMLClass13AnnotationsOneToManyAssociation14 = uMLClass13.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLClass13AnnotationsOneToManyAssociation14.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLClass13AnnotationsOneToManyAssociation14.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                  oneToManyAssociation14 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between oneToManyAssociation14 and uMLClass13
                  JavaSDM.ensure ( oneToManyAssociation14.hasInElements ("many", uMLClass13) ) ;
                   
                  // bind createMethod11: CreateMethodAnnotation
                  fujaba__IterUMLClass13AnnotationsCreateMethod11 = uMLClass13.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLClass13AnnotationsCreateMethod11.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLClass13AnnotationsCreateMethod11.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                        createMethod11 = (CreateMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between createMethod11 and uMLClass13
                        JavaSDM.ensure ( createMethod11.hasInElements ("creates", uMLClass13) ) ;
                         
                        // bind uMLClass12: UMLClass
                        fujaba__IterOneToManyAssociation14ElementsUMLClass12 = oneToManyAssociation14.iteratorOfElements ("one") ;
                        while ( fujaba__IterOneToManyAssociation14ElementsUMLClass12.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOneToManyAssociation14ElementsUMLClass12.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              uMLClass12 = (UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLClass13.equals (uMLClass12)) ) ;
                               
                              // bind uMLMethod15: UMLMethod
                              fujaba__IterCreateMethod11ElementsUMLMethod15 = createMethod11.iteratorOfElements ("method") ;
                              while ( fujaba__IterCreateMethod11ElementsUMLMethod15.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCreateMethod11ElementsUMLMethod15.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    uMLMethod15 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check To-One-Link 'parent' between uMLMethod15 and uMLClass12
                                    JavaSDM.ensure ( (uMLMethod15.getParent () != null) && uMLMethod15.getParent ().equals (uMLClass12) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLClass12 is really bound
                                          JavaSDM.ensure ( uMLClass12 != null ) ;
                                           
                                          // check object uMLClass13 is really bound
                                          JavaSDM.ensure ( uMLClass13 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLClass12.equals (uMLClass13)) ) ;
                                           
                                          // bind flyweight: FlyweightAnnotation
                                          fujaba__IterUMLClass12AnnotationsFlyweight = uMLClass12.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterUMLClass12AnnotationsFlyweight.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLClass12AnnotationsFlyweight.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof FlyweightAnnotation ) ;
                                                flyweight = (FlyweightAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between flyweight and uMLClass12
                                                JavaSDM.ensure ( flyweight.hasInElements ("factory", uMLClass12) ) ;
                                                 
                                                // check To-Many-Link 'elements' between flyweight and uMLClass13
                                                JavaSDM.ensure ( flyweight.hasInElements ("flyweight", uMLClass13) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLClass12 is really bound
                                             JavaSDM.ensure ( uMLClass12 != null ) ;
                                              
                                             // check object uMLClass13 is really bound
                                             JavaSDM.ensure ( uMLClass13 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(uMLClass12.equals (uMLClass13)) ) ;
                                              
                                             // create object
                                             flyweight = new FlyweightAnnotation ( ) ;
                                              
                                             // assign statement
                                             flyweight.setClassification (1);
                                              
                                             // create link
                                             flyweight.addToElements ("factory", uMLClass12);
                                              
                                             // create link
                                             flyweight.addToElements ("flyweight", uMLClass13);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object createMethod11 is really bound
                                             JavaSDM.ensure ( createMethod11 != null ) ;
                                              
                                             // check object oneToManyAssociation14 is really bound
                                             JavaSDM.ensure ( oneToManyAssociation14 != null ) ;
                                              
                                             // check object flyweight is really bound
                                             JavaSDM.ensure ( flyweight != null ) ;
                                              
                                             // create link
                                             flyweight.addToAntecedentAnnos (createMethod11);
                                              
                                             // create link
                                             flyweight.addToAntecedentAnnos (oneToManyAssociation14);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (flyweight) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object flyweight is really bound
            JavaSDM.ensure ( flyweight != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("flyweight", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (flyweight) ;
   }


   private GFRNAnnotation annotateUsingTrigger_CreateMethodRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod1 = null ;
      Iterator fujaba__IterCreateMethod1ElementsUMLClass3 = null ;
      Iterator fujaba__IterCreateMethod1ElementsUMLMethod5 = null ;
      Iterator fujaba__IterUMLClass3AnnotationsFlyweight = null ;
      Iterator fujaba__IterUMLClass3AnnotationsOneToManyAssociation4 = null ;
      FlyweightAnnotation flyweight = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation4 = null ;
      UMLClass uMLClass2 = null ;
      UMLClass uMLClass3 = null ;
      UMLMethod uMLMethod5 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_CreateMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof CreateMethodAnnotation ) ;
             
            // explicit type cast
            createMethod1 = (CreateMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLClass3: UMLClass
            fujaba__IterCreateMethod1ElementsUMLClass3 = createMethod1.iteratorOfElements ("creates") ;
            while ( fujaba__IterCreateMethod1ElementsUMLClass3.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterCreateMethod1ElementsUMLClass3.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  uMLClass3 = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLMethod5: UMLMethod
                  fujaba__IterCreateMethod1ElementsUMLMethod5 = createMethod1.iteratorOfElements ("method") ;
                  while ( fujaba__IterCreateMethod1ElementsUMLMethod5.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCreateMethod1ElementsUMLMethod5.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod5 = (UMLMethod) fujaba__TmpObject ;
                         
                        // bind uMLClass2: UMLClass
                        uMLClass2 = uMLMethod5.getParent () ;
                        JavaSDM.ensure ( uMLClass2 != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLClass3.equals (uMLClass2)) ) ;
                         
                        // bind oneToManyAssociation4: OneToManyAssociationAnnotation
                        fujaba__IterUMLClass3AnnotationsOneToManyAssociation4 = uMLClass3.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLClass3AnnotationsOneToManyAssociation4.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLClass3AnnotationsOneToManyAssociation4.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                              oneToManyAssociation4 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between oneToManyAssociation4 and uMLClass3
                              JavaSDM.ensure ( oneToManyAssociation4.hasInElements ("many", uMLClass3) ) ;
                               
                              // check To-Many-Link 'elements' between oneToManyAssociation4 and uMLClass2
                              JavaSDM.ensure ( oneToManyAssociation4.hasInElements ("one", uMLClass2) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object uMLClass2 is really bound
                                    JavaSDM.ensure ( uMLClass2 != null ) ;
                                     
                                    // check object uMLClass3 is really bound
                                    JavaSDM.ensure ( uMLClass3 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLClass2.equals (uMLClass3)) ) ;
                                     
                                    // bind flyweight: FlyweightAnnotation
                                    fujaba__IterUMLClass3AnnotationsFlyweight = uMLClass3.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterUMLClass3AnnotationsFlyweight.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterUMLClass3AnnotationsFlyweight.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof FlyweightAnnotation ) ;
                                          flyweight = (FlyweightAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between flyweight and uMLClass3
                                          JavaSDM.ensure ( flyweight.hasInElements ("flyweight", uMLClass3) ) ;
                                           
                                          // check To-Many-Link 'elements' between flyweight and uMLClass2
                                          JavaSDM.ensure ( flyweight.hasInElements ("factory", uMLClass2) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object uMLClass2 is really bound
                                       JavaSDM.ensure ( uMLClass2 != null ) ;
                                        
                                       // check object uMLClass3 is really bound
                                       JavaSDM.ensure ( uMLClass3 != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(uMLClass2.equals (uMLClass3)) ) ;
                                        
                                       // create object
                                       flyweight = new FlyweightAnnotation ( ) ;
                                        
                                       // assign statement
                                       flyweight.setClassification (1);
                                        
                                       // create link
                                       flyweight.addToElements ("factory", uMLClass2);
                                        
                                       // create link
                                       flyweight.addToElements ("flyweight", uMLClass3);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object createMethod1 is really bound
                                       JavaSDM.ensure ( createMethod1 != null ) ;
                                        
                                       // check object oneToManyAssociation4 is really bound
                                       JavaSDM.ensure ( oneToManyAssociation4 != null ) ;
                                        
                                       // check object flyweight is really bound
                                       JavaSDM.ensure ( flyweight != null ) ;
                                        
                                       // create link
                                       flyweight.addToAntecedentAnnos (createMethod1);
                                        
                                       // create link
                                       flyweight.addToAntecedentAnnos (oneToManyAssociation4);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (flyweight) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object flyweight is really bound
            JavaSDM.ensure ( flyweight != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_CreateMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (flyweight) ;
   }


   private GFRNAnnotation annotateUsingTrigger_OneToManyAssociationRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod16 = null ;
      Iterator fujaba__IterOneToManyAssociation19ElementsUMLClass17 = null ;
      Iterator fujaba__IterOneToManyAssociation19ElementsUMLClass18 = null ;
      Iterator fujaba__IterUMLClass17MethodsUMLMethod20 = null ;
      Iterator fujaba__IterUMLClass18AnnotationsCreateMethod16 = null ;
      Iterator fujaba__IterUMLClass18AnnotationsFlyweight = null ;
      FlyweightAnnotation flyweight = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation19 = null ;
      UMLClass uMLClass17 = null ;
      UMLClass uMLClass18 = null ;
      UMLMethod uMLMethod20 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_OneToManyAssociation", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OneToManyAssociationAnnotation ) ;
             
            // explicit type cast
            oneToManyAssociation19 = (OneToManyAssociationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLClass17: UMLClass
            fujaba__IterOneToManyAssociation19ElementsUMLClass17 = oneToManyAssociation19.iteratorOfElements ("one") ;
            while ( fujaba__IterOneToManyAssociation19ElementsUMLClass17.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOneToManyAssociation19ElementsUMLClass17.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  uMLClass17 = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLClass18: UMLClass
                  fujaba__IterOneToManyAssociation19ElementsUMLClass18 = oneToManyAssociation19.iteratorOfElements ("many") ;
                  while ( fujaba__IterOneToManyAssociation19ElementsUMLClass18.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterOneToManyAssociation19ElementsUMLClass18.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        uMLClass18 = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLClass17.equals (uMLClass18)) ) ;
                         
                        // bind uMLMethod20: UMLMethod
                        fujaba__IterUMLClass17MethodsUMLMethod20 = uMLClass17.iteratorOfMethods () ;
                        while ( fujaba__IterUMLClass17MethodsUMLMethod20.hasNext () )
                        {
                           try
                           {
                              uMLMethod20 = (UMLMethod) fujaba__IterUMLClass17MethodsUMLMethod20.next () ;
                               
                              // bind createMethod16: CreateMethodAnnotation
                              fujaba__IterUMLClass18AnnotationsCreateMethod16 = uMLClass18.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLClass18AnnotationsCreateMethod16.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLClass18AnnotationsCreateMethod16.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                                    createMethod16 = (CreateMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between createMethod16 and uMLClass18
                                    JavaSDM.ensure ( createMethod16.hasInElements ("creates", uMLClass18) ) ;
                                     
                                    // check To-Many-Link 'elements' between createMethod16 and uMLMethod20
                                    JavaSDM.ensure ( createMethod16.hasInElements ("method", uMLMethod20) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLClass17 is really bound
                                          JavaSDM.ensure ( uMLClass17 != null ) ;
                                           
                                          // check object uMLClass18 is really bound
                                          JavaSDM.ensure ( uMLClass18 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLClass17.equals (uMLClass18)) ) ;
                                           
                                          // bind flyweight: FlyweightAnnotation
                                          fujaba__IterUMLClass18AnnotationsFlyweight = uMLClass18.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterUMLClass18AnnotationsFlyweight.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLClass18AnnotationsFlyweight.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof FlyweightAnnotation ) ;
                                                flyweight = (FlyweightAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between flyweight and uMLClass18
                                                JavaSDM.ensure ( flyweight.hasInElements ("flyweight", uMLClass18) ) ;
                                                 
                                                // check To-Many-Link 'elements' between flyweight and uMLClass17
                                                JavaSDM.ensure ( flyweight.hasInElements ("factory", uMLClass17) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLClass17 is really bound
                                             JavaSDM.ensure ( uMLClass17 != null ) ;
                                              
                                             // check object uMLClass18 is really bound
                                             JavaSDM.ensure ( uMLClass18 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(uMLClass17.equals (uMLClass18)) ) ;
                                              
                                             // create object
                                             flyweight = new FlyweightAnnotation ( ) ;
                                              
                                             // assign statement
                                             flyweight.setClassification (1);
                                              
                                             // create link
                                             flyweight.addToElements ("factory", uMLClass17);
                                              
                                             // create link
                                             flyweight.addToElements ("flyweight", uMLClass18);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object createMethod16 is really bound
                                             JavaSDM.ensure ( createMethod16 != null ) ;
                                              
                                             // check object oneToManyAssociation19 is really bound
                                             JavaSDM.ensure ( oneToManyAssociation19 != null ) ;
                                              
                                             // check object flyweight is really bound
                                             JavaSDM.ensure ( flyweight != null ) ;
                                              
                                             // create link
                                             flyweight.addToAntecedentAnnos (createMethod16);
                                              
                                             // create link
                                             flyweight.addToAntecedentAnnos (oneToManyAssociation19);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (flyweight) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object flyweight is really bound
            JavaSDM.ensure ( flyweight != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_OneToManyAssociation", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (flyweight) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("factory", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("flyweight", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof CreateMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_CreateMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OneToManyAssociationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_OneToManyAssociation", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod16 = null ;
      Iterator fujaba__IterCreateMethod16ElementsUMLClass24 = null ;
      Iterator fujaba__IterOneToManyAssociation19ElementsUMLClass22 = null ;
      Iterator fujaba__IterUMLClass17MethodsUMLMethod21 = null ;
      Iterator fujaba__IterUMLClass22MethodsUMLMethod23 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation19 = null ;
      UMLClass uMLClass17 = null ;
      UMLClass uMLClass18 = null ;
      UMLClass uMLClass22 = null ;
      UMLClass uMLClass24 = null ;
      UMLMethod uMLMethod21 = null ;
      UMLMethod uMLMethod23 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("CreateMethod") || annotation.equals ("CreateMethodSubType") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass17 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod21: UMLMethod
            fujaba__IterUMLClass17MethodsUMLMethod21 = uMLClass17.iteratorOfMethods () ;
            while ( fujaba__IterUMLClass17MethodsUMLMethod21.hasNext () )
            {
               try
               {
                  uMLMethod21 = (UMLMethod) fujaba__IterUMLClass17MethodsUMLMethod21.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod21);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass18 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLClass18);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OneToManyAssociationAnnotation ) ;
             
            // explicit type cast
            oneToManyAssociation19 = (OneToManyAssociationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLClass22: UMLClass
            fujaba__IterOneToManyAssociation19ElementsUMLClass22 = oneToManyAssociation19.iteratorOfElements ("one") ;
            while ( fujaba__IterOneToManyAssociation19ElementsUMLClass22.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOneToManyAssociation19ElementsUMLClass22.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  uMLClass22 = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLMethod23: UMLMethod
                  fujaba__IterUMLClass22MethodsUMLMethod23 = uMLClass22.iteratorOfMethods () ;
                  while ( fujaba__IterUMLClass22MethodsUMLMethod23.hasNext () )
                  {
                     try
                     {
                        uMLMethod23 = (UMLMethod) fujaba__IterUMLClass22MethodsUMLMethod23.next () ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod23);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("OneToManyAssociation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass22 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLClass22);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass18 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLClass18);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof CreateMethodAnnotation ) ;
             
            // explicit type cast
            createMethod16 = (CreateMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLClass24: UMLClass
            fujaba__IterCreateMethod16ElementsUMLClass24 = createMethod16.iteratorOfElements ("creates") ;
            while ( fujaba__IterCreateMethod16ElementsUMLClass24.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterCreateMethod16ElementsUMLClass24.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  uMLClass24 = (UMLClass) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (uMLClass24);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
