package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLAttr;

public class OneToManyAssociationEngine
extends GFRNEngine
{
   private  OneToManyAssociationEngine()
   {
   }

   private static OneToManyAssociationEngine theOneToManyAssociationEngine;

   public static OneToManyAssociationEngine get()
   {
      if (theOneToManyAssociationEngine == null)
      {
         theOneToManyAssociationEngine = new OneToManyAssociationEngine ();
      }
      return theOneToManyAssociationEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation oneToManyAssociation = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         oneToManyAssociation = this.annotateUsingOneRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( oneToManyAssociation != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (oneToManyAssociation) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            oneToManyAssociation = this.annotateUsingTrigger_MultiReferenceRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( oneToManyAssociation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (oneToManyAssociation) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               oneToManyAssociation = this.annotateUsingManyRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            try
            {
               fujaba__Success = false ;
                
               // constraint
               JavaSDM.ensure ( oneToManyAssociation != null ) ;
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            if ( fujaba__Success )
            {
               return (oneToManyAssociation) ;
            }
            else
            {
               try
               {
                  fujaba__Success = false ;
                   
                  // collabStatBegin 1 is empty !
                  oneToManyAssociation = this.annotateUsingTrigger_SingleReferenceRole(asgElement);
                   
                  // collabStatEnd
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               return (oneToManyAssociation) ;
            }
         }
      }
   }


   private GFRNAnnotation annotateUsingManyRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterMultiReference15ElementsUMLAttr14 = null ;
      Iterator fujaba__IterUMLAttr17AnnotationsSingleReference18 = null ;
      Iterator fujaba__IterUMLClass13AnnotationsOneToManyAssociation = null ;
      Iterator fujaba__IterUMLClass16AnnotationsMultiReference15 = null ;
      Iterator fujaba__IterUMLClass16AttrsUMLAttr17 = null ;
      MultiReferenceAnnotation multiReference15 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation = null ;
      SingleReferenceAnnotation singleReference18 = null ;
      UMLAttr uMLAttr14 = null ;
      UMLAttr uMLAttr17 = null ;
      UMLClass uMLClass13 = null ;
      UMLClass uMLClass16 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("many", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass16 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr17: UMLAttr
            fujaba__IterUMLClass16AttrsUMLAttr17 = uMLClass16.iteratorOfAttrs () ;
            while ( fujaba__IterUMLClass16AttrsUMLAttr17.hasNext () )
            {
               try
               {
                  uMLAttr17 = (UMLAttr) fujaba__IterUMLClass16AttrsUMLAttr17.next () ;
                   
                  // bind multiReference15: MultiReferenceAnnotation
                  fujaba__IterUMLClass16AnnotationsMultiReference15 = uMLClass16.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLClass16AnnotationsMultiReference15.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLClass16AnnotationsMultiReference15.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                        multiReference15 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between multiReference15 and uMLClass16
                        JavaSDM.ensure ( multiReference15.hasInElements ("references", uMLClass16) ) ;
                         
                        // bind singleReference18: SingleReferenceAnnotation
                        fujaba__IterUMLAttr17AnnotationsSingleReference18 = uMLAttr17.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLAttr17AnnotationsSingleReference18.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLAttr17AnnotationsSingleReference18.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                              singleReference18 = (SingleReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between singleReference18 and uMLAttr17
                              JavaSDM.ensure ( singleReference18.hasInElements ("field", uMLAttr17) ) ;
                               
                              // bind uMLAttr14: UMLAttr
                              fujaba__IterMultiReference15ElementsUMLAttr14 = multiReference15.iteratorOfElements ("field") ;
                              while ( fujaba__IterMultiReference15ElementsUMLAttr14.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterMultiReference15ElementsUMLAttr14.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                    uMLAttr14 = (UMLAttr) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLAttr17.equals (uMLAttr14)) ) ;
                                     
                                    // bind uMLClass13: UMLClass
                                    uMLClass13 = uMLAttr14.getParent () ;
                                    JavaSDM.ensure ( uMLClass13 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLClass16.equals (uMLClass13)) ) ;
                                     
                                    // check To-Many-Link 'elements' between singleReference18 and uMLClass13
                                    JavaSDM.ensure ( singleReference18.hasInElements ("references", uMLClass13) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLClass13 is really bound
                                          JavaSDM.ensure ( uMLClass13 != null ) ;
                                           
                                          // check object uMLClass16 is really bound
                                          JavaSDM.ensure ( uMLClass16 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLClass13.equals (uMLClass16)) ) ;
                                           
                                          // bind oneToManyAssociation: OneToManyAssociationAnnotation
                                          fujaba__IterUMLClass13AnnotationsOneToManyAssociation = uMLClass13.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterUMLClass13AnnotationsOneToManyAssociation.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLClass13AnnotationsOneToManyAssociation.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                                                oneToManyAssociation = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between oneToManyAssociation and uMLClass13
                                                JavaSDM.ensure ( oneToManyAssociation.hasInElements ("one", uMLClass13) ) ;
                                                 
                                                // check To-Many-Link 'elements' between oneToManyAssociation and uMLClass16
                                                JavaSDM.ensure ( oneToManyAssociation.hasInElements ("many", uMLClass16) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLClass13 is really bound
                                             JavaSDM.ensure ( uMLClass13 != null ) ;
                                              
                                             // check object uMLClass16 is really bound
                                             JavaSDM.ensure ( uMLClass16 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(uMLClass13.equals (uMLClass16)) ) ;
                                              
                                             // create object
                                             oneToManyAssociation = new OneToManyAssociationAnnotation ( ) ;
                                              
                                             // assign statement
                                             oneToManyAssociation.setClassification (0);
                                              
                                             // create link
                                             oneToManyAssociation.addToElements ("one", uMLClass13);
                                              
                                             // create link
                                             oneToManyAssociation.addToElements ("many", uMLClass16);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object multiReference15 is really bound
                                             JavaSDM.ensure ( multiReference15 != null ) ;
                                              
                                             // check object singleReference18 is really bound
                                             JavaSDM.ensure ( singleReference18 != null ) ;
                                              
                                             // check object oneToManyAssociation is really bound
                                             JavaSDM.ensure ( oneToManyAssociation != null ) ;
                                              
                                             // create link
                                             oneToManyAssociation.addToAntecedentAnnos (multiReference15);
                                              
                                             // create link
                                             oneToManyAssociation.addToAntecedentAnnos (singleReference18);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (oneToManyAssociation) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object oneToManyAssociation is really bound
            JavaSDM.ensure ( oneToManyAssociation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("many", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (oneToManyAssociation) ;
   }


   private GFRNAnnotation annotateUsingOneRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterSingleReference6ElementsUMLAttr5 = null ;
      Iterator fujaba__IterUMLAttr2AnnotationsMultiReference3 = null ;
      Iterator fujaba__IterUMLClass1AnnotationsSingleReference6 = null ;
      Iterator fujaba__IterUMLClass1AttrsUMLAttr2 = null ;
      Iterator fujaba__IterUMLClass4AnnotationsOneToManyAssociation = null ;
      MultiReferenceAnnotation multiReference3 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation = null ;
      SingleReferenceAnnotation singleReference6 = null ;
      UMLAttr uMLAttr2 = null ;
      UMLAttr uMLAttr5 = null ;
      UMLClass uMLClass1 = null ;
      UMLClass uMLClass4 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("one", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass1 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr2: UMLAttr
            fujaba__IterUMLClass1AttrsUMLAttr2 = uMLClass1.iteratorOfAttrs () ;
            while ( fujaba__IterUMLClass1AttrsUMLAttr2.hasNext () )
            {
               try
               {
                  uMLAttr2 = (UMLAttr) fujaba__IterUMLClass1AttrsUMLAttr2.next () ;
                   
                  // bind singleReference6: SingleReferenceAnnotation
                  fujaba__IterUMLClass1AnnotationsSingleReference6 = uMLClass1.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLClass1AnnotationsSingleReference6.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLClass1AnnotationsSingleReference6.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                        singleReference6 = (SingleReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between singleReference6 and uMLClass1
                        JavaSDM.ensure ( singleReference6.hasInElements ("references", uMLClass1) ) ;
                         
                        // bind multiReference3: MultiReferenceAnnotation
                        fujaba__IterUMLAttr2AnnotationsMultiReference3 = uMLAttr2.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLAttr2AnnotationsMultiReference3.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLAttr2AnnotationsMultiReference3.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                              multiReference3 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between multiReference3 and uMLAttr2
                              JavaSDM.ensure ( multiReference3.hasInElements ("field", uMLAttr2) ) ;
                               
                              // bind uMLAttr5: UMLAttr
                              fujaba__IterSingleReference6ElementsUMLAttr5 = singleReference6.iteratorOfElements ("field") ;
                              while ( fujaba__IterSingleReference6ElementsUMLAttr5.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterSingleReference6ElementsUMLAttr5.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                    uMLAttr5 = (UMLAttr) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLAttr2.equals (uMLAttr5)) ) ;
                                     
                                    // bind uMLClass4: UMLClass
                                    uMLClass4 = uMLAttr5.getParent () ;
                                    JavaSDM.ensure ( uMLClass4 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLClass1.equals (uMLClass4)) ) ;
                                     
                                    // check To-Many-Link 'elements' between multiReference3 and uMLClass4
                                    JavaSDM.ensure ( multiReference3.hasInElements ("references", uMLClass4) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLClass1 is really bound
                                          JavaSDM.ensure ( uMLClass1 != null ) ;
                                           
                                          // check object uMLClass4 is really bound
                                          JavaSDM.ensure ( uMLClass4 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLClass1.equals (uMLClass4)) ) ;
                                           
                                          // bind oneToManyAssociation: OneToManyAssociationAnnotation
                                          fujaba__IterUMLClass4AnnotationsOneToManyAssociation = uMLClass4.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterUMLClass4AnnotationsOneToManyAssociation.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLClass4AnnotationsOneToManyAssociation.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                                                oneToManyAssociation = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between oneToManyAssociation and uMLClass4
                                                JavaSDM.ensure ( oneToManyAssociation.hasInElements ("many", uMLClass4) ) ;
                                                 
                                                // check To-Many-Link 'elements' between oneToManyAssociation and uMLClass1
                                                JavaSDM.ensure ( oneToManyAssociation.hasInElements ("one", uMLClass1) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLClass1 is really bound
                                             JavaSDM.ensure ( uMLClass1 != null ) ;
                                              
                                             // check object uMLClass4 is really bound
                                             JavaSDM.ensure ( uMLClass4 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(uMLClass1.equals (uMLClass4)) ) ;
                                              
                                             // create object
                                             oneToManyAssociation = new OneToManyAssociationAnnotation ( ) ;
                                              
                                             // assign statement
                                             oneToManyAssociation.setClassification (0);
                                              
                                             // create link
                                             oneToManyAssociation.addToElements ("one", uMLClass1);
                                              
                                             // create link
                                             oneToManyAssociation.addToElements ("many", uMLClass4);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object multiReference3 is really bound
                                             JavaSDM.ensure ( multiReference3 != null ) ;
                                              
                                             // check object singleReference6 is really bound
                                             JavaSDM.ensure ( singleReference6 != null ) ;
                                              
                                             // check object oneToManyAssociation is really bound
                                             JavaSDM.ensure ( oneToManyAssociation != null ) ;
                                              
                                             // create link
                                             oneToManyAssociation.addToAntecedentAnnos (multiReference3);
                                              
                                             // create link
                                             oneToManyAssociation.addToAntecedentAnnos (singleReference6);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (oneToManyAssociation) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object oneToManyAssociation is really bound
            JavaSDM.ensure ( oneToManyAssociation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("one", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (oneToManyAssociation) ;
   }


   private GFRNAnnotation annotateUsingTrigger_MultiReferenceRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterMultiReference9ElementsUMLAttr8 = null ;
      Iterator fujaba__IterMultiReference9ElementsUMLClass10 = null ;
      Iterator fujaba__IterUMLClass10AttrsUMLAttr11 = null ;
      Iterator fujaba__IterUMLClass7AnnotationsOneToManyAssociation = null ;
      Iterator fujaba__IterUMLClass7AnnotationsSingleReference12 = null ;
      MultiReferenceAnnotation multiReference9 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation = null ;
      SingleReferenceAnnotation singleReference12 = null ;
      UMLAttr uMLAttr11 = null ;
      UMLAttr uMLAttr8 = null ;
      UMLClass uMLClass10 = null ;
      UMLClass uMLClass7 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_MultiReference", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference9 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr8: UMLAttr
            fujaba__IterMultiReference9ElementsUMLAttr8 = multiReference9.iteratorOfElements ("field") ;
            while ( fujaba__IterMultiReference9ElementsUMLAttr8.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference9ElementsUMLAttr8.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  uMLAttr8 = (UMLAttr) fujaba__TmpObject ;
                   
                  // bind uMLClass7: UMLClass
                  uMLClass7 = uMLAttr8.getParent () ;
                  JavaSDM.ensure ( uMLClass7 != null ) ;
                   
                  // bind uMLClass10: UMLClass
                  fujaba__IterMultiReference9ElementsUMLClass10 = multiReference9.iteratorOfElements ("references") ;
                  while ( fujaba__IterMultiReference9ElementsUMLClass10.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterMultiReference9ElementsUMLClass10.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        uMLClass10 = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLClass7.equals (uMLClass10)) ) ;
                         
                        // bind singleReference12: SingleReferenceAnnotation
                        fujaba__IterUMLClass7AnnotationsSingleReference12 = uMLClass7.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLClass7AnnotationsSingleReference12.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLClass7AnnotationsSingleReference12.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                              singleReference12 = (SingleReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between singleReference12 and uMLClass7
                              JavaSDM.ensure ( singleReference12.hasInElements ("references", uMLClass7) ) ;
                               
                              // bind uMLAttr11: UMLAttr
                              fujaba__IterUMLClass10AttrsUMLAttr11 = uMLClass10.iteratorOfAttrs () ;
                              while ( fujaba__IterUMLClass10AttrsUMLAttr11.hasNext () )
                              {
                                 try
                                 {
                                    uMLAttr11 = (UMLAttr) fujaba__IterUMLClass10AttrsUMLAttr11.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLAttr8.equals (uMLAttr11)) ) ;
                                     
                                    // check To-Many-Link 'elements' between singleReference12 and uMLAttr11
                                    JavaSDM.ensure ( singleReference12.hasInElements ("field", uMLAttr11) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLClass7 is really bound
                                          JavaSDM.ensure ( uMLClass7 != null ) ;
                                           
                                          // check object uMLClass10 is really bound
                                          JavaSDM.ensure ( uMLClass10 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLClass7.equals (uMLClass10)) ) ;
                                           
                                          // bind oneToManyAssociation: OneToManyAssociationAnnotation
                                          fujaba__IterUMLClass7AnnotationsOneToManyAssociation = uMLClass7.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterUMLClass7AnnotationsOneToManyAssociation.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLClass7AnnotationsOneToManyAssociation.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                                                oneToManyAssociation = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between oneToManyAssociation and uMLClass7
                                                JavaSDM.ensure ( oneToManyAssociation.hasInElements ("one", uMLClass7) ) ;
                                                 
                                                // check To-Many-Link 'elements' between oneToManyAssociation and uMLClass10
                                                JavaSDM.ensure ( oneToManyAssociation.hasInElements ("many", uMLClass10) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLClass7 is really bound
                                             JavaSDM.ensure ( uMLClass7 != null ) ;
                                              
                                             // check object uMLClass10 is really bound
                                             JavaSDM.ensure ( uMLClass10 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(uMLClass7.equals (uMLClass10)) ) ;
                                              
                                             // create object
                                             oneToManyAssociation = new OneToManyAssociationAnnotation ( ) ;
                                              
                                             // assign statement
                                             oneToManyAssociation.setClassification (0);
                                              
                                             // create link
                                             oneToManyAssociation.addToElements ("one", uMLClass7);
                                              
                                             // create link
                                             oneToManyAssociation.addToElements ("many", uMLClass10);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object multiReference9 is really bound
                                             JavaSDM.ensure ( multiReference9 != null ) ;
                                              
                                             // check object singleReference12 is really bound
                                             JavaSDM.ensure ( singleReference12 != null ) ;
                                              
                                             // check object oneToManyAssociation is really bound
                                             JavaSDM.ensure ( oneToManyAssociation != null ) ;
                                              
                                             // create link
                                             oneToManyAssociation.addToAntecedentAnnos (multiReference9);
                                              
                                             // create link
                                             oneToManyAssociation.addToAntecedentAnnos (singleReference12);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (oneToManyAssociation) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object oneToManyAssociation is really bound
            JavaSDM.ensure ( oneToManyAssociation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_MultiReference", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (oneToManyAssociation) ;
   }


   private GFRNAnnotation annotateUsingTrigger_SingleReferenceRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterSingleReference24ElementsUMLAttr23 = null ;
      Iterator fujaba__IterSingleReference24ElementsUMLClass19 = null ;
      Iterator fujaba__IterUMLClass19AttrsUMLAttr20 = null ;
      Iterator fujaba__IterUMLClass22AnnotationsMultiReference21 = null ;
      Iterator fujaba__IterUMLClass22AnnotationsOneToManyAssociation = null ;
      MultiReferenceAnnotation multiReference21 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation = null ;
      SingleReferenceAnnotation singleReference24 = null ;
      UMLAttr uMLAttr20 = null ;
      UMLAttr uMLAttr23 = null ;
      UMLClass uMLClass19 = null ;
      UMLClass uMLClass22 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_SingleReference", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof SingleReferenceAnnotation ) ;
             
            // explicit type cast
            singleReference24 = (SingleReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLClass19: UMLClass
            fujaba__IterSingleReference24ElementsUMLClass19 = singleReference24.iteratorOfElements ("references") ;
            while ( fujaba__IterSingleReference24ElementsUMLClass19.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSingleReference24ElementsUMLClass19.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  uMLClass19 = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLAttr23: UMLAttr
                  fujaba__IterSingleReference24ElementsUMLAttr23 = singleReference24.iteratorOfElements ("field") ;
                  while ( fujaba__IterSingleReference24ElementsUMLAttr23.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterSingleReference24ElementsUMLAttr23.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        uMLAttr23 = (UMLAttr) fujaba__TmpObject ;
                         
                        // bind uMLClass22: UMLClass
                        uMLClass22 = uMLAttr23.getParent () ;
                        JavaSDM.ensure ( uMLClass22 != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLClass19.equals (uMLClass22)) ) ;
                         
                        // bind uMLAttr20: UMLAttr
                        fujaba__IterUMLClass19AttrsUMLAttr20 = uMLClass19.iteratorOfAttrs () ;
                        while ( fujaba__IterUMLClass19AttrsUMLAttr20.hasNext () )
                        {
                           try
                           {
                              uMLAttr20 = (UMLAttr) fujaba__IterUMLClass19AttrsUMLAttr20.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLAttr23.equals (uMLAttr20)) ) ;
                               
                              // bind multiReference21: MultiReferenceAnnotation
                              fujaba__IterUMLClass22AnnotationsMultiReference21 = uMLClass22.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLClass22AnnotationsMultiReference21.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLClass22AnnotationsMultiReference21.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                    multiReference21 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between multiReference21 and uMLClass22
                                    JavaSDM.ensure ( multiReference21.hasInElements ("references", uMLClass22) ) ;
                                     
                                    // check To-Many-Link 'elements' between multiReference21 and uMLAttr20
                                    JavaSDM.ensure ( multiReference21.hasInElements ("field", uMLAttr20) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLClass19 is really bound
                                          JavaSDM.ensure ( uMLClass19 != null ) ;
                                           
                                          // check object uMLClass22 is really bound
                                          JavaSDM.ensure ( uMLClass22 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLClass19.equals (uMLClass22)) ) ;
                                           
                                          // bind oneToManyAssociation: OneToManyAssociationAnnotation
                                          fujaba__IterUMLClass22AnnotationsOneToManyAssociation = uMLClass22.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterUMLClass22AnnotationsOneToManyAssociation.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLClass22AnnotationsOneToManyAssociation.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                                                oneToManyAssociation = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between oneToManyAssociation and uMLClass22
                                                JavaSDM.ensure ( oneToManyAssociation.hasInElements ("many", uMLClass22) ) ;
                                                 
                                                // check To-Many-Link 'elements' between oneToManyAssociation and uMLClass19
                                                JavaSDM.ensure ( oneToManyAssociation.hasInElements ("one", uMLClass19) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLClass19 is really bound
                                             JavaSDM.ensure ( uMLClass19 != null ) ;
                                              
                                             // check object uMLClass22 is really bound
                                             JavaSDM.ensure ( uMLClass22 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(uMLClass19.equals (uMLClass22)) ) ;
                                              
                                             // create object
                                             oneToManyAssociation = new OneToManyAssociationAnnotation ( ) ;
                                              
                                             // assign statement
                                             oneToManyAssociation.setClassification (0);
                                              
                                             // create link
                                             oneToManyAssociation.addToElements ("one", uMLClass19);
                                              
                                             // create link
                                             oneToManyAssociation.addToElements ("many", uMLClass22);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object multiReference21 is really bound
                                             JavaSDM.ensure ( multiReference21 != null ) ;
                                              
                                             // check object singleReference24 is really bound
                                             JavaSDM.ensure ( singleReference24 != null ) ;
                                              
                                             // check object oneToManyAssociation is really bound
                                             JavaSDM.ensure ( oneToManyAssociation != null ) ;
                                              
                                             // create link
                                             oneToManyAssociation.addToAntecedentAnnos (multiReference21);
                                              
                                             // create link
                                             oneToManyAssociation.addToAntecedentAnnos (singleReference24);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (oneToManyAssociation) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object oneToManyAssociation is really bound
            JavaSDM.ensure ( oneToManyAssociation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_SingleReference", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (oneToManyAssociation) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("one", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("many", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof MultiReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_MultiReference", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof SingleReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_SingleReference", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterMultiReference21ElementsUMLAttr29 = null ;
      Iterator fujaba__IterSingleReference24ElementsUMLClass26 = null ;
      Iterator fujaba__IterUMLClass19AttrsUMLAttr25 = null ;
      Iterator fujaba__IterUMLClass22AttrsUMLAttr28 = null ;
      Iterator fujaba__IterUMLClass26AttrsUMLAttr27 = null ;
      MultiReferenceAnnotation multiReference21 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SingleReferenceAnnotation singleReference24 = null ;
      UMLAttr uMLAttr25 = null ;
      UMLAttr uMLAttr27 = null ;
      UMLAttr uMLAttr28 = null ;
      UMLAttr uMLAttr29 = null ;
      UMLClass uMLClass19 = null ;
      UMLClass uMLClass22 = null ;
      UMLClass uMLClass26 = null ;
      UMLClass uMLClass30 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("MultiReference") || annotation.equals ("ArrayReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass19 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr25: UMLAttr
            fujaba__IterUMLClass19AttrsUMLAttr25 = uMLClass19.iteratorOfAttrs () ;
            while ( fujaba__IterUMLClass19AttrsUMLAttr25.hasNext () )
            {
               try
               {
                  uMLAttr25 = (UMLAttr) fujaba__IterUMLClass19AttrsUMLAttr25.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLAttr25);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass22 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLClass22);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof SingleReferenceAnnotation ) ;
             
            // explicit type cast
            singleReference24 = (SingleReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLClass26: UMLClass
            fujaba__IterSingleReference24ElementsUMLClass26 = singleReference24.iteratorOfElements ("references") ;
            while ( fujaba__IterSingleReference24ElementsUMLClass26.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSingleReference24ElementsUMLClass26.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  uMLClass26 = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLAttr27: UMLAttr
                  fujaba__IterUMLClass26AttrsUMLAttr27 = uMLClass26.iteratorOfAttrs () ;
                  while ( fujaba__IterUMLClass26AttrsUMLAttr27.hasNext () )
                  {
                     try
                     {
                        uMLAttr27 = (UMLAttr) fujaba__IterUMLClass26AttrsUMLAttr27.next () ;
                         
                        {
                           //  for each flow
                           set.add (uMLAttr27);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("SingleReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass26 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLClass26);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass22 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr28: UMLAttr
            fujaba__IterUMLClass22AttrsUMLAttr28 = uMLClass22.iteratorOfAttrs () ;
            while ( fujaba__IterUMLClass22AttrsUMLAttr28.hasNext () )
            {
               try
               {
                  uMLAttr28 = (UMLAttr) fujaba__IterUMLClass22AttrsUMLAttr28.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLAttr28);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference21 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr29: UMLAttr
            fujaba__IterMultiReference21ElementsUMLAttr29 = multiReference21.iteratorOfElements ("field") ;
            while ( fujaba__IterMultiReference21ElementsUMLAttr29.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference21ElementsUMLAttr29.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  uMLAttr29 = (UMLAttr) fujaba__TmpObject ;
                   
                  // bind uMLClass30: UMLClass
                  uMLClass30 = uMLAttr29.getParent () ;
                  JavaSDM.ensure ( uMLClass30 != null ) ;
                   
                  {
                     //  for each flow
                     set.add (uMLClass30);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
