package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLParam;

public class VisitorEngine
extends GFRNEngine
{
   private  VisitorEngine()
   {
   }

   private static VisitorEngine theVisitorEngine;

   public static VisitorEngine get()
   {
      if (theVisitorEngine == null)
      {
         theVisitorEngine = new VisitorEngine ();
      }
      return theVisitorEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation visitor = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         visitor = this.annotateUsingRootRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( visitor != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (visitor) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            visitor = this.annotateUsingTrigger_GeneralizationRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( visitor != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (visitor) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               visitor = this.annotateUsingVisitorRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            try
            {
               fujaba__Success = false ;
                
               // constraint
               JavaSDM.ensure ( visitor != null ) ;
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            if ( fujaba__Success )
            {
               return (visitor) ;
            }
            else
            {
               try
               {
                  fujaba__Success = false ;
                   
                  // collabStatBegin 1 is empty !
                  visitor = this.annotateUsingTrigger_GeneralizationRole(asgElement);
                   
                  // collabStatEnd
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               return (visitor) ;
            }
         }
      }
   }


   private GFRNAnnotation annotateUsingRootRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAcceptParamUMLParam5 = null ;
      Iterator fujaba__IterGeneralization1ElementsSub2 = null ;
      Iterator fujaba__IterGeneralization4ElementsSub1 = null ;
      Iterator fujaba__IterRootClassAnnotationsGeneralization1 = null ;
      Iterator fujaba__IterRootClassAnnotationsGeneralization4 = null ;
      Iterator fujaba__IterRootClassAnnotationsVisitor = null ;
      Iterator fujaba__IterRootClassMethodsAccept = null ;
      Iterator fujaba__IterSub1RevParamTypeUMLParam3 = null ;
      Iterator fujaba__IterSub2RevParamTypeUMLParam2 = null ;
      Iterator fujaba__IterVisitorClassMethodsVisit1 = null ;
      Iterator fujaba__IterVisitorClassMethodsVisit2 = null ;
      GeneralizationAnnotation generalization1 = null ;
      GeneralizationAnnotation generalization4 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass rootClass = null ;
      UMLClass sub1 = null ;
      UMLClass sub2 = null ;
      UMLClass visitorClass = null ;
      UMLMethod accept = null ;
      UMLMethod visit1 = null ;
      UMLMethod visit2 = null ;
      UMLParam uMLParam2 = null ;
      UMLParam uMLParam3 = null ;
      UMLParam uMLParam5 = null ;
      VisitorAnnotation visitor = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("root", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            rootClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind accept: UMLMethod
            fujaba__IterRootClassMethodsAccept = rootClass.iteratorOfMethods () ;
            while ( fujaba__IterRootClassMethodsAccept.hasNext () )
            {
               try
               {
                  accept = (UMLMethod) fujaba__IterRootClassMethodsAccept.next () ;
                   
                  // bind generalization1: GeneralizationAnnotation
                  fujaba__IterRootClassAnnotationsGeneralization1 = rootClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterRootClassAnnotationsGeneralization1.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterRootClassAnnotationsGeneralization1.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization1 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization1 and rootClass
                        JavaSDM.ensure ( generalization1.hasInElements ("superClass", rootClass) ) ;
                         
                        // bind generalization4: GeneralizationAnnotation
                        fujaba__IterRootClassAnnotationsGeneralization4 = rootClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterRootClassAnnotationsGeneralization4.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterRootClassAnnotationsGeneralization4.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization4 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization4 and rootClass
                              JavaSDM.ensure ( generalization4.hasInElements ("superClass", rootClass) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(generalization1.equals (generalization4)) ) ;
                               
                              // bind uMLParam5: UMLParam
                              fujaba__IterAcceptParamUMLParam5 = accept.iteratorOfParam () ;
                              while ( fujaba__IterAcceptParamUMLParam5.hasNext () )
                              {
                                 try
                                 {
                                    uMLParam5 = (UMLParam) fujaba__IterAcceptParamUMLParam5.next () ;
                                     
                                    // bind visitorClass: UMLClass
                                    fujaba__TmpObject = uMLParam5.getParamType () ;
                                    JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    visitorClass = (UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(rootClass.equals (visitorClass)) ) ;
                                     
                                    // bind sub2: UMLClass
                                    fujaba__IterGeneralization1ElementsSub2 = generalization1.iteratorOfElements ("subClass") ;
                                    while ( fujaba__IterGeneralization1ElementsSub2.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization1ElementsSub2.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          sub2 = (UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(rootClass.equals (sub2)) && !(visitorClass.equals (sub2)) ) ;
                                           
                                          // bind sub1: UMLClass
                                          fujaba__IterGeneralization4ElementsSub1 = generalization4.iteratorOfElements ("subClass") ;
                                          while ( fujaba__IterGeneralization4ElementsSub1.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterGeneralization4ElementsSub1.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                sub1 = (UMLClass) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(rootClass.equals (sub1)) && !(sub2.equals (sub1)) && !(visitorClass.equals (sub1)) ) ;
                                                 
                                                // bind visit2: UMLMethod
                                                fujaba__IterVisitorClassMethodsVisit2 = visitorClass.iteratorOfMethods () ;
                                                while ( fujaba__IterVisitorClassMethodsVisit2.hasNext () )
                                                {
                                                   try
                                                   {
                                                      visit2 = (UMLMethod) fujaba__IterVisitorClassMethodsVisit2.next () ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(accept.equals (visit2)) ) ;
                                                       
                                                      // bind visit1: UMLMethod
                                                      fujaba__IterVisitorClassMethodsVisit1 = visitorClass.iteratorOfMethods () ;
                                                      while ( fujaba__IterVisitorClassMethodsVisit1.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            visit1 = (UMLMethod) fujaba__IterVisitorClassMethodsVisit1.next () ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(accept.equals (visit1)) && !(visit2.equals (visit1)) ) ;
                                                             
                                                            // bind uMLParam2: UMLParam
                                                            fujaba__IterSub2RevParamTypeUMLParam2 = sub2.iteratorOfRevParamType () ;
                                                            while ( fujaba__IterSub2RevParamTypeUMLParam2.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  uMLParam2 = (UMLParam) fujaba__IterSub2RevParamTypeUMLParam2.next () ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(uMLParam5.equals (uMLParam2)) ) ;
                                                                   
                                                                  // check To-One-Link 'revParam' between uMLParam2 and visit2
                                                                  JavaSDM.ensure ( (uMLParam2.getRevParam () != null) && uMLParam2.getRevParam ().equals (visit2) ) ;
                                                                   
                                                                  // bind uMLParam3: UMLParam
                                                                  fujaba__IterSub1RevParamTypeUMLParam3 = sub1.iteratorOfRevParamType () ;
                                                                  while ( fujaba__IterSub1RevParamTypeUMLParam3.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        uMLParam3 = (UMLParam) fujaba__IterSub1RevParamTypeUMLParam3.next () ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(uMLParam2.equals (uMLParam3)) && !(uMLParam5.equals (uMLParam3)) ) ;
                                                                         
                                                                        // check To-One-Link 'revParam' between uMLParam3 and visit1
                                                                        JavaSDM.ensure ( (uMLParam3.getRevParam () != null) && uMLParam3.getRevParam ().equals (visit1) ) ;
                                                                         
                                                                        {
                                                                           //  for each flow
                                                                           try
                                                                           {
                                                                              fujaba__Success = false ;
                                                                               
                                                                              // check object rootClass is really bound
                                                                              JavaSDM.ensure ( rootClass != null ) ;
                                                                               
                                                                              // check object visitorClass is really bound
                                                                              JavaSDM.ensure ( visitorClass != null ) ;
                                                                               
                                                                              // check isomorphic binding
                                                                              JavaSDM.ensure ( !(rootClass.equals (visitorClass)) ) ;
                                                                               
                                                                              // bind visitor: VisitorAnnotation
                                                                              fujaba__IterRootClassAnnotationsVisitor = rootClass.iteratorOfAnnotations () ;
                                                                              while ( !(fujaba__Success) && fujaba__IterRootClassAnnotationsVisitor.hasNext () )
                                                                              {
                                                                                 try
                                                                                 {
                                                                                    fujaba__TmpObject = fujaba__IterRootClassAnnotationsVisitor.next () ;
                                                                                    JavaSDM.ensure ( fujaba__TmpObject instanceof VisitorAnnotation ) ;
                                                                                    visitor = (VisitorAnnotation) fujaba__TmpObject ;
                                                                                     
                                                                                    // check Reverse-Qualified-Link 'elements' between visitor and rootClass
                                                                                    JavaSDM.ensure ( visitor.hasInElements ("root", rootClass) ) ;
                                                                                     
                                                                                    // check To-Many-Link 'elements' between visitor and visitorClass
                                                                                    JavaSDM.ensure ( visitor.hasInElements ("visitor", visitorClass) ) ;
                                                                                     
                                                                                    fujaba__Success = true ;
                                                                                 }
                                                                                 catch ( JavaSDMException fujaba__InternalException )
                                                                                 {
                                                                                 }
                                                                              }
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                              fujaba__Success = false ;
                                                                           }
                                                                            
                                                                           if ( !(fujaba__Success) )
                                                                           {
                                                                              try
                                                                              {
                                                                                 fujaba__Success = false ;
                                                                                  
                                                                                 // check object rootClass is really bound
                                                                                 JavaSDM.ensure ( rootClass != null ) ;
                                                                                  
                                                                                 // check object visitorClass is really bound
                                                                                 JavaSDM.ensure ( visitorClass != null ) ;
                                                                                  
                                                                                 // check isomorphic binding
                                                                                 JavaSDM.ensure ( !(rootClass.equals (visitorClass)) ) ;
                                                                                  
                                                                                 // check object accept is really bound
                                                                                 JavaSDM.ensure ( accept != null ) ;
                                                                                  
                                                                                 // check object sub2 is really bound
                                                                                 JavaSDM.ensure ( sub2 != null ) ;
                                                                                  
                                                                                 // check isomorphic binding
                                                                                 JavaSDM.ensure ( !(rootClass.equals (sub2)) && !(visitorClass.equals (sub2)) ) ;
                                                                                  
                                                                                 // check object visit2 is really bound
                                                                                 JavaSDM.ensure ( visit2 != null ) ;
                                                                                  
                                                                                 // check isomorphic binding
                                                                                 JavaSDM.ensure ( !(accept.equals (visit2)) ) ;
                                                                                  
                                                                                 // check object visit1 is really bound
                                                                                 JavaSDM.ensure ( visit1 != null ) ;
                                                                                  
                                                                                 // check isomorphic binding
                                                                                 JavaSDM.ensure ( !(accept.equals (visit1)) && !(visit2.equals (visit1)) ) ;
                                                                                  
                                                                                 // check object sub1 is really bound
                                                                                 JavaSDM.ensure ( sub1 != null ) ;
                                                                                  
                                                                                 // check isomorphic binding
                                                                                 JavaSDM.ensure ( !(rootClass.equals (sub1)) && !(visitorClass.equals (sub1)) && !(sub2.equals (sub1)) ) ;
                                                                                  
                                                                                 // create object
                                                                                 visitor = new VisitorAnnotation ( ) ;
                                                                                  
                                                                                 // assign statement
                                                                                 visitor.setClassification (1);
                                                                                  
                                                                                 // create link
                                                                                 visitor.addToElements ("root", rootClass);
                                                                                  
                                                                                 // create link
                                                                                 visitor.addToElements ("visitor", visitorClass);
                                                                                  
                                                                                 // create link
                                                                                 visitor.addToBoundObjects ("accept", accept);
                                                                                  
                                                                                 // create link
                                                                                 visitor.addToBoundObjects ("rootClass", rootClass);
                                                                                  
                                                                                 // create link
                                                                                 visitor.addToBoundObjects ("sub2", sub2);
                                                                                  
                                                                                 // create link
                                                                                 visitor.addToBoundObjects ("visit2", visit2);
                                                                                  
                                                                                 // create link
                                                                                 visitor.addToBoundObjects ("visitorClass", visitorClass);
                                                                                  
                                                                                 // create link
                                                                                 visitor.addToBoundObjects ("visit1", visit1);
                                                                                  
                                                                                 // create link
                                                                                 visitor.addToBoundObjects ("sub1", sub1);
                                                                                  
                                                                                 fujaba__Success = true ;
                                                                              }
                                                                              catch ( JavaSDMException fujaba__InternalException )
                                                                              {
                                                                                 fujaba__Success = false ;
                                                                              }
                                                                               
                                                                              try
                                                                              {
                                                                                 fujaba__Success = false ;
                                                                                  
                                                                                 // check object generalization1 is really bound
                                                                                 JavaSDM.ensure ( generalization1 != null ) ;
                                                                                  
                                                                                 // check object generalization4 is really bound
                                                                                 JavaSDM.ensure ( generalization4 != null ) ;
                                                                                  
                                                                                 // check isomorphic binding
                                                                                 JavaSDM.ensure ( !(generalization1.equals (generalization4)) ) ;
                                                                                  
                                                                                 // check object visitor is really bound
                                                                                 JavaSDM.ensure ( visitor != null ) ;
                                                                                  
                                                                                 // create link
                                                                                 visitor.addToAntecedentAnnos (generalization1);
                                                                                  
                                                                                 // create link
                                                                                 visitor.addToAntecedentAnnos (generalization4);
                                                                                  
                                                                                 fujaba__Success = true ;
                                                                              }
                                                                              catch ( JavaSDMException fujaba__InternalException )
                                                                              {
                                                                                 fujaba__Success = false ;
                                                                              }
                                                                               
                                                                              return (visitor) ;
                                                                           }
                                                                        } //  end for each flow
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object visitor is really bound
            JavaSDM.ensure ( visitor != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("root", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (visitor) ;
   }


   private GFRNAnnotation annotateUsingTrigger_GeneralizationRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAcceptParamUMLParam10 = null ;
      Iterator fujaba__IterGeneralization6ElementsRootClass = null ;
      Iterator fujaba__IterGeneralization6ElementsSub2 = null ;
      Iterator fujaba__IterGeneralization9ElementsSub1 = null ;
      Iterator fujaba__IterRootClassAnnotationsGeneralization9 = null ;
      Iterator fujaba__IterRootClassMethodsAccept = null ;
      Iterator fujaba__IterSub1RevParamTypeUMLParam8 = null ;
      Iterator fujaba__IterSub2RevParamTypeUMLParam7 = null ;
      Iterator fujaba__IterVisitorClassAnnotationsVisitor = null ;
      Iterator fujaba__IterVisitorClassMethodsVisit1 = null ;
      GeneralizationAnnotation generalization6 = null ;
      GeneralizationAnnotation generalization9 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass rootClass = null ;
      UMLClass sub1 = null ;
      UMLClass sub2 = null ;
      UMLClass visitorClass = null ;
      UMLMethod accept = null ;
      UMLMethod visit1 = null ;
      UMLMethod visit2 = null ;
      UMLParam uMLParam10 = null ;
      UMLParam uMLParam7 = null ;
      UMLParam uMLParam8 = null ;
      VisitorAnnotation visitor = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization6 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind rootClass: UMLClass
            fujaba__IterGeneralization6ElementsRootClass = generalization6.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization6ElementsRootClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization6ElementsRootClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  rootClass = (UMLClass) fujaba__TmpObject ;
                   
                  // bind sub2: UMLClass
                  fujaba__IterGeneralization6ElementsSub2 = generalization6.iteratorOfElements ("subClass") ;
                  while ( fujaba__IterGeneralization6ElementsSub2.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization6ElementsSub2.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        sub2 = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(rootClass.equals (sub2)) ) ;
                         
                        // bind accept: UMLMethod
                        fujaba__IterRootClassMethodsAccept = rootClass.iteratorOfMethods () ;
                        while ( fujaba__IterRootClassMethodsAccept.hasNext () )
                        {
                           try
                           {
                              accept = (UMLMethod) fujaba__IterRootClassMethodsAccept.next () ;
                               
                              // bind generalization9: GeneralizationAnnotation
                              fujaba__IterRootClassAnnotationsGeneralization9 = rootClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterRootClassAnnotationsGeneralization9.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterRootClassAnnotationsGeneralization9.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization9 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization9 and rootClass
                                    JavaSDM.ensure ( generalization9.hasInElements ("superClass", rootClass) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(generalization6.equals (generalization9)) ) ;
                                     
                                    // bind uMLParam7: UMLParam
                                    fujaba__IterSub2RevParamTypeUMLParam7 = sub2.iteratorOfRevParamType () ;
                                    while ( fujaba__IterSub2RevParamTypeUMLParam7.hasNext () )
                                    {
                                       try
                                       {
                                          uMLParam7 = (UMLParam) fujaba__IterSub2RevParamTypeUMLParam7.next () ;
                                           
                                          // bind visit2: UMLMethod
                                          visit2 = uMLParam7.getRevParam () ;
                                          JavaSDM.ensure ( visit2 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(accept.equals (visit2)) ) ;
                                           
                                          // bind visitorClass: UMLClass
                                          visitorClass = visit2.getParent () ;
                                          JavaSDM.ensure ( visitorClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(rootClass.equals (visitorClass)) && !(sub2.equals (visitorClass)) ) ;
                                           
                                          // bind uMLParam10: UMLParam
                                          fujaba__IterAcceptParamUMLParam10 = accept.iteratorOfParam () ;
                                          while ( fujaba__IterAcceptParamUMLParam10.hasNext () )
                                          {
                                             try
                                             {
                                                uMLParam10 = (UMLParam) fujaba__IterAcceptParamUMLParam10.next () ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLParam7.equals (uMLParam10)) ) ;
                                                 
                                                // check To-One-Link 'paramType' between uMLParam10 and visitorClass
                                                JavaSDM.ensure ( (uMLParam10.getParamType () != null) && uMLParam10.getParamType ().equals (visitorClass) ) ;
                                                 
                                                // bind sub1: UMLClass
                                                fujaba__IterGeneralization9ElementsSub1 = generalization9.iteratorOfElements ("subClass") ;
                                                while ( fujaba__IterGeneralization9ElementsSub1.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterGeneralization9ElementsSub1.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                      sub1 = (UMLClass) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(rootClass.equals (sub1)) && !(sub2.equals (sub1)) && !(visitorClass.equals (sub1)) ) ;
                                                       
                                                      // bind visit1: UMLMethod
                                                      fujaba__IterVisitorClassMethodsVisit1 = visitorClass.iteratorOfMethods () ;
                                                      while ( fujaba__IterVisitorClassMethodsVisit1.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            visit1 = (UMLMethod) fujaba__IterVisitorClassMethodsVisit1.next () ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(accept.equals (visit1)) && !(visit2.equals (visit1)) ) ;
                                                             
                                                            // bind uMLParam8: UMLParam
                                                            fujaba__IterSub1RevParamTypeUMLParam8 = sub1.iteratorOfRevParamType () ;
                                                            while ( fujaba__IterSub1RevParamTypeUMLParam8.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  uMLParam8 = (UMLParam) fujaba__IterSub1RevParamTypeUMLParam8.next () ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(uMLParam7.equals (uMLParam8)) && !(uMLParam10.equals (uMLParam8)) ) ;
                                                                   
                                                                  // check To-One-Link 'revParam' between uMLParam8 and visit1
                                                                  JavaSDM.ensure ( (uMLParam8.getRevParam () != null) && uMLParam8.getRevParam ().equals (visit1) ) ;
                                                                   
                                                                  {
                                                                     //  for each flow
                                                                     try
                                                                     {
                                                                        fujaba__Success = false ;
                                                                         
                                                                        // check object rootClass is really bound
                                                                        JavaSDM.ensure ( rootClass != null ) ;
                                                                         
                                                                        // check object visitorClass is really bound
                                                                        JavaSDM.ensure ( visitorClass != null ) ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(rootClass.equals (visitorClass)) ) ;
                                                                         
                                                                        // bind visitor: VisitorAnnotation
                                                                        fujaba__IterVisitorClassAnnotationsVisitor = visitorClass.iteratorOfAnnotations () ;
                                                                        while ( !(fujaba__Success) && fujaba__IterVisitorClassAnnotationsVisitor.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              fujaba__TmpObject = fujaba__IterVisitorClassAnnotationsVisitor.next () ;
                                                                              JavaSDM.ensure ( fujaba__TmpObject instanceof VisitorAnnotation ) ;
                                                                              visitor = (VisitorAnnotation) fujaba__TmpObject ;
                                                                               
                                                                              // check Reverse-Qualified-Link 'elements' between visitor and visitorClass
                                                                              JavaSDM.ensure ( visitor.hasInElements ("visitor", visitorClass) ) ;
                                                                               
                                                                              // check To-Many-Link 'elements' between visitor and rootClass
                                                                              JavaSDM.ensure ( visitor.hasInElements ("root", rootClass) ) ;
                                                                               
                                                                              fujaba__Success = true ;
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                        fujaba__Success = false ;
                                                                     }
                                                                      
                                                                     if ( !(fujaba__Success) )
                                                                     {
                                                                        try
                                                                        {
                                                                           fujaba__Success = false ;
                                                                            
                                                                           // check object rootClass is really bound
                                                                           JavaSDM.ensure ( rootClass != null ) ;
                                                                            
                                                                           // check object visitorClass is really bound
                                                                           JavaSDM.ensure ( visitorClass != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(rootClass.equals (visitorClass)) ) ;
                                                                            
                                                                           // check object accept is really bound
                                                                           JavaSDM.ensure ( accept != null ) ;
                                                                            
                                                                           // check object sub2 is really bound
                                                                           JavaSDM.ensure ( sub2 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(rootClass.equals (sub2)) && !(visitorClass.equals (sub2)) ) ;
                                                                            
                                                                           // check object visit2 is really bound
                                                                           JavaSDM.ensure ( visit2 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(accept.equals (visit2)) ) ;
                                                                            
                                                                           // check object visit1 is really bound
                                                                           JavaSDM.ensure ( visit1 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(accept.equals (visit1)) && !(visit2.equals (visit1)) ) ;
                                                                            
                                                                           // check object sub1 is really bound
                                                                           JavaSDM.ensure ( sub1 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(rootClass.equals (sub1)) && !(visitorClass.equals (sub1)) && !(sub2.equals (sub1)) ) ;
                                                                            
                                                                           // create object
                                                                           visitor = new VisitorAnnotation ( ) ;
                                                                            
                                                                           // assign statement
                                                                           visitor.setClassification (1);
                                                                            
                                                                           // create link
                                                                           visitor.addToElements ("root", rootClass);
                                                                            
                                                                           // create link
                                                                           visitor.addToElements ("visitor", visitorClass);
                                                                            
                                                                           // create link
                                                                           visitor.addToBoundObjects ("accept", accept);
                                                                            
                                                                           // create link
                                                                           visitor.addToBoundObjects ("rootClass", rootClass);
                                                                            
                                                                           // create link
                                                                           visitor.addToBoundObjects ("sub2", sub2);
                                                                            
                                                                           // create link
                                                                           visitor.addToBoundObjects ("visit2", visit2);
                                                                            
                                                                           // create link
                                                                           visitor.addToBoundObjects ("visitorClass", visitorClass);
                                                                            
                                                                           // create link
                                                                           visitor.addToBoundObjects ("visit1", visit1);
                                                                            
                                                                           // create link
                                                                           visitor.addToBoundObjects ("sub1", sub1);
                                                                            
                                                                           fujaba__Success = true ;
                                                                        }
                                                                        catch ( JavaSDMException fujaba__InternalException )
                                                                        {
                                                                           fujaba__Success = false ;
                                                                        }
                                                                         
                                                                        try
                                                                        {
                                                                           fujaba__Success = false ;
                                                                            
                                                                           // check object generalization6 is really bound
                                                                           JavaSDM.ensure ( generalization6 != null ) ;
                                                                            
                                                                           // check object generalization9 is really bound
                                                                           JavaSDM.ensure ( generalization9 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(generalization6.equals (generalization9)) ) ;
                                                                            
                                                                           // check object visitor is really bound
                                                                           JavaSDM.ensure ( visitor != null ) ;
                                                                            
                                                                           // create link
                                                                           visitor.addToAntecedentAnnos (generalization6);
                                                                            
                                                                           // create link
                                                                           visitor.addToAntecedentAnnos (generalization9);
                                                                            
                                                                           fujaba__Success = true ;
                                                                        }
                                                                        catch ( JavaSDMException fujaba__InternalException )
                                                                        {
                                                                           fujaba__Success = false ;
                                                                        }
                                                                         
                                                                        return (visitor) ;
                                                                     }
                                                                  } //  end for each flow
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object visitor is really bound
            JavaSDM.ensure ( visitor != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_Generalization", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (visitor) ;
   }


   private GFRNAnnotation annotateUsingVisitorRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterRootClassAnnotationsGeneralization11 = null ;
      Iterator fujaba__IterRootClassAnnotationsGeneralization14 = null ;
      Iterator fujaba__IterVisit1ParamUMLParam13 = null ;
      Iterator fujaba__IterVisit2ParamUMLParam12 = null ;
      Iterator fujaba__IterVisitorClassAnnotationsVisitor = null ;
      Iterator fujaba__IterVisitorClassMethodsVisit1 = null ;
      Iterator fujaba__IterVisitorClassMethodsVisit2 = null ;
      Iterator fujaba__IterVisitorClassRevParamTypeUMLParam15 = null ;
      GeneralizationAnnotation generalization11 = null ;
      GeneralizationAnnotation generalization14 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass rootClass = null ;
      UMLClass sub1 = null ;
      UMLClass sub2 = null ;
      UMLClass visitorClass = null ;
      UMLMethod accept = null ;
      UMLMethod visit1 = null ;
      UMLMethod visit2 = null ;
      UMLParam uMLParam12 = null ;
      UMLParam uMLParam13 = null ;
      UMLParam uMLParam15 = null ;
      VisitorAnnotation visitor = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("visitor", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            visitorClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind visit2: UMLMethod
            fujaba__IterVisitorClassMethodsVisit2 = visitorClass.iteratorOfMethods () ;
            while ( fujaba__IterVisitorClassMethodsVisit2.hasNext () )
            {
               try
               {
                  visit2 = (UMLMethod) fujaba__IterVisitorClassMethodsVisit2.next () ;
                   
                  // bind visit1: UMLMethod
                  fujaba__IterVisitorClassMethodsVisit1 = visitorClass.iteratorOfMethods () ;
                  while ( fujaba__IterVisitorClassMethodsVisit1.hasNext () )
                  {
                     try
                     {
                        visit1 = (UMLMethod) fujaba__IterVisitorClassMethodsVisit1.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(visit2.equals (visit1)) ) ;
                         
                        // bind uMLParam15: UMLParam
                        fujaba__IterVisitorClassRevParamTypeUMLParam15 = visitorClass.iteratorOfRevParamType () ;
                        while ( fujaba__IterVisitorClassRevParamTypeUMLParam15.hasNext () )
                        {
                           try
                           {
                              uMLParam15 = (UMLParam) fujaba__IterVisitorClassRevParamTypeUMLParam15.next () ;
                               
                              // bind accept: UMLMethod
                              accept = uMLParam15.getRevParam () ;
                              JavaSDM.ensure ( accept != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(visit2.equals (accept)) && !(visit1.equals (accept)) ) ;
                               
                              // bind rootClass: UMLClass
                              rootClass = accept.getParent () ;
                              JavaSDM.ensure ( rootClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(visitorClass.equals (rootClass)) ) ;
                               
                              // bind uMLParam12: UMLParam
                              fujaba__IterVisit2ParamUMLParam12 = visit2.iteratorOfParam () ;
                              while ( fujaba__IterVisit2ParamUMLParam12.hasNext () )
                              {
                                 try
                                 {
                                    uMLParam12 = (UMLParam) fujaba__IterVisit2ParamUMLParam12.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLParam15.equals (uMLParam12)) ) ;
                                     
                                    // bind sub2: UMLClass
                                    fujaba__TmpObject = uMLParam12.getParamType () ;
                                    JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    sub2 = (UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(rootClass.equals (sub2)) && !(visitorClass.equals (sub2)) ) ;
                                     
                                    // bind uMLParam13: UMLParam
                                    fujaba__IterVisit1ParamUMLParam13 = visit1.iteratorOfParam () ;
                                    while ( fujaba__IterVisit1ParamUMLParam13.hasNext () )
                                    {
                                       try
                                       {
                                          uMLParam13 = (UMLParam) fujaba__IterVisit1ParamUMLParam13.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLParam12.equals (uMLParam13)) && !(uMLParam15.equals (uMLParam13)) ) ;
                                           
                                          // bind sub1: UMLClass
                                          fujaba__TmpObject = uMLParam13.getParamType () ;
                                          JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          sub1 = (UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(rootClass.equals (sub1)) && !(sub2.equals (sub1)) && !(visitorClass.equals (sub1)) ) ;
                                           
                                          // bind generalization11: GeneralizationAnnotation
                                          fujaba__IterRootClassAnnotationsGeneralization11 = rootClass.iteratorOfAnnotations () ;
                                          while ( fujaba__IterRootClassAnnotationsGeneralization11.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterRootClassAnnotationsGeneralization11.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                generalization11 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between generalization11 and rootClass
                                                JavaSDM.ensure ( generalization11.hasInElements ("superClass", rootClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between generalization11 and sub2
                                                JavaSDM.ensure ( generalization11.hasInElements ("subClass", sub2) ) ;
                                                 
                                                // bind generalization14: GeneralizationAnnotation
                                                fujaba__IterRootClassAnnotationsGeneralization14 = rootClass.iteratorOfAnnotations () ;
                                                while ( fujaba__IterRootClassAnnotationsGeneralization14.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterRootClassAnnotationsGeneralization14.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                      generalization14 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between generalization14 and rootClass
                                                      JavaSDM.ensure ( generalization14.hasInElements ("superClass", rootClass) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(generalization11.equals (generalization14)) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between generalization14 and sub1
                                                      JavaSDM.ensure ( generalization14.hasInElements ("subClass", sub1) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object rootClass is really bound
                                                            JavaSDM.ensure ( rootClass != null ) ;
                                                             
                                                            // check object visitorClass is really bound
                                                            JavaSDM.ensure ( visitorClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(rootClass.equals (visitorClass)) ) ;
                                                             
                                                            // bind visitor: VisitorAnnotation
                                                            fujaba__IterVisitorClassAnnotationsVisitor = visitorClass.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterVisitorClassAnnotationsVisitor.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterVisitorClassAnnotationsVisitor.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof VisitorAnnotation ) ;
                                                                  visitor = (VisitorAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between visitor and visitorClass
                                                                  JavaSDM.ensure ( visitor.hasInElements ("visitor", visitorClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between visitor and rootClass
                                                                  JavaSDM.ensure ( visitor.hasInElements ("root", rootClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object rootClass is really bound
                                                               JavaSDM.ensure ( rootClass != null ) ;
                                                                
                                                               // check object visitorClass is really bound
                                                               JavaSDM.ensure ( visitorClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(rootClass.equals (visitorClass)) ) ;
                                                                
                                                               // check object accept is really bound
                                                               JavaSDM.ensure ( accept != null ) ;
                                                                
                                                               // check object sub2 is really bound
                                                               JavaSDM.ensure ( sub2 != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(rootClass.equals (sub2)) && !(visitorClass.equals (sub2)) ) ;
                                                                
                                                               // check object visit2 is really bound
                                                               JavaSDM.ensure ( visit2 != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(accept.equals (visit2)) ) ;
                                                                
                                                               // check object visit1 is really bound
                                                               JavaSDM.ensure ( visit1 != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(accept.equals (visit1)) && !(visit2.equals (visit1)) ) ;
                                                                
                                                               // check object sub1 is really bound
                                                               JavaSDM.ensure ( sub1 != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(rootClass.equals (sub1)) && !(visitorClass.equals (sub1)) && !(sub2.equals (sub1)) ) ;
                                                                
                                                               // create object
                                                               visitor = new VisitorAnnotation ( ) ;
                                                                
                                                               // assign statement
                                                               visitor.setClassification (1);
                                                                
                                                               // create link
                                                               visitor.addToElements ("root", rootClass);
                                                                
                                                               // create link
                                                               visitor.addToElements ("visitor", visitorClass);
                                                                
                                                               // create link
                                                               visitor.addToBoundObjects ("accept", accept);
                                                                
                                                               // create link
                                                               visitor.addToBoundObjects ("rootClass", rootClass);
                                                                
                                                               // create link
                                                               visitor.addToBoundObjects ("sub2", sub2);
                                                                
                                                               // create link
                                                               visitor.addToBoundObjects ("visit2", visit2);
                                                                
                                                               // create link
                                                               visitor.addToBoundObjects ("visitorClass", visitorClass);
                                                                
                                                               // create link
                                                               visitor.addToBoundObjects ("visit1", visit1);
                                                                
                                                               // create link
                                                               visitor.addToBoundObjects ("sub1", sub1);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object generalization11 is really bound
                                                               JavaSDM.ensure ( generalization11 != null ) ;
                                                                
                                                               // check object generalization14 is really bound
                                                               JavaSDM.ensure ( generalization14 != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(generalization11.equals (generalization14)) ) ;
                                                                
                                                               // check object visitor is really bound
                                                               JavaSDM.ensure ( visitor != null ) ;
                                                                
                                                               // create link
                                                               visitor.addToAntecedentAnnos (generalization11);
                                                                
                                                               // create link
                                                               visitor.addToAntecedentAnnos (generalization14);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (visitor) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object visitor is really bound
            JavaSDM.ensure ( visitor != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("visitor", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (visitor) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("root", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("visitor", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterGeneralization19ElementsSub1 = null ;
      Iterator fujaba__IterGeneralization25ElementsRootClass = null ;
      Iterator fujaba__IterSub1RevParamTypeUMLParam22 = null ;
      Iterator fujaba__IterSub2AnnotationsGeneralization25 = null ;
      Iterator fujaba__IterVisit2ParamUMLParam21 = null ;
      Iterator fujaba__IterVisit2ParamUMLParam23 = null ;
      Iterator fujaba__IterVisit2ParamUMLParam24 = null ;
      Iterator fujaba__IterVisitorClassMethodsVisit2 = null ;
      GeneralizationAnnotation generalization19 = null ;
      GeneralizationAnnotation generalization25 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass rootClass = null ;
      UMLClass sub1 = null ;
      UMLClass sub2 = null ;
      UMLClass visitorClass = null ;
      UMLMethod visit1 = null ;
      UMLMethod visit2 = null ;
      UMLParam uMLParam21 = null ;
      UMLParam uMLParam22 = null ;
      UMLParam uMLParam23 = null ;
      UMLParam uMLParam24 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Generalization") || annotation.equals ("MultiLevelGeneralization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            rootClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (rootClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            visitorClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind visit2: UMLMethod
            fujaba__IterVisitorClassMethodsVisit2 = visitorClass.iteratorOfMethods () ;
            while ( fujaba__IterVisitorClassMethodsVisit2.hasNext () )
            {
               try
               {
                  visit2 = (UMLMethod) fujaba__IterVisitorClassMethodsVisit2.next () ;
                   
                  // bind uMLParam21: UMLParam
                  fujaba__IterVisit2ParamUMLParam21 = visit2.iteratorOfParam () ;
                  while ( fujaba__IterVisit2ParamUMLParam21.hasNext () )
                  {
                     try
                     {
                        uMLParam21 = (UMLParam) fujaba__IterVisit2ParamUMLParam21.next () ;
                         
                        // bind sub2: UMLClass
                        fujaba__TmpObject = uMLParam21.getParamType () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        sub2 = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(visitorClass.equals (sub2)) ) ;
                         
                        {
                           //  for each flow
                           set.add (sub2);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization19 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind sub1: UMLClass
            fujaba__IterGeneralization19ElementsSub1 = generalization19.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization19ElementsSub1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization19ElementsSub1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  sub1 = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLParam22: UMLParam
                  fujaba__IterSub1RevParamTypeUMLParam22 = sub1.iteratorOfRevParamType () ;
                  while ( fujaba__IterSub1RevParamTypeUMLParam22.hasNext () )
                  {
                     try
                     {
                        uMLParam22 = (UMLParam) fujaba__IterSub1RevParamTypeUMLParam22.next () ;
                         
                        // bind visit1: UMLMethod
                        visit1 = uMLParam22.getRevParam () ;
                        JavaSDM.ensure ( visit1 != null ) ;
                         
                        // bind visitorClass: UMLClass
                        visitorClass = visit1.getParent () ;
                        JavaSDM.ensure ( visitorClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(sub1.equals (visitorClass)) ) ;
                         
                        // bind visit2: UMLMethod
                        fujaba__IterVisitorClassMethodsVisit2 = visitorClass.iteratorOfMethods () ;
                        while ( fujaba__IterVisitorClassMethodsVisit2.hasNext () )
                        {
                           try
                           {
                              visit2 = (UMLMethod) fujaba__IterVisitorClassMethodsVisit2.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(visit1.equals (visit2)) ) ;
                               
                              // bind uMLParam23: UMLParam
                              fujaba__IterVisit2ParamUMLParam23 = visit2.iteratorOfParam () ;
                              while ( fujaba__IterVisit2ParamUMLParam23.hasNext () )
                              {
                                 try
                                 {
                                    uMLParam23 = (UMLParam) fujaba__IterVisit2ParamUMLParam23.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLParam22.equals (uMLParam23)) ) ;
                                     
                                    // bind sub2: UMLClass
                                    fujaba__TmpObject = uMLParam23.getParamType () ;
                                    JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    sub2 = (UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(sub1.equals (sub2)) && !(visitorClass.equals (sub2)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (sub2);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") || annotation.equals ("MultiLevelGeneralization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            rootClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (rootClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            visitorClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind visit2: UMLMethod
            fujaba__IterVisitorClassMethodsVisit2 = visitorClass.iteratorOfMethods () ;
            while ( fujaba__IterVisitorClassMethodsVisit2.hasNext () )
            {
               try
               {
                  visit2 = (UMLMethod) fujaba__IterVisitorClassMethodsVisit2.next () ;
                   
                  // bind uMLParam24: UMLParam
                  fujaba__IterVisit2ParamUMLParam24 = visit2.iteratorOfParam () ;
                  while ( fujaba__IterVisit2ParamUMLParam24.hasNext () )
                  {
                     try
                     {
                        uMLParam24 = (UMLParam) fujaba__IterVisit2ParamUMLParam24.next () ;
                         
                        // bind sub2: UMLClass
                        fujaba__TmpObject = uMLParam24.getParamType () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        sub2 = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(visitorClass.equals (sub2)) ) ;
                         
                        // bind generalization25: GeneralizationAnnotation
                        fujaba__IterSub2AnnotationsGeneralization25 = sub2.iteratorOfAnnotations () ;
                        while ( fujaba__IterSub2AnnotationsGeneralization25.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterSub2AnnotationsGeneralization25.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization25 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization25 and sub2
                              JavaSDM.ensure ( generalization25.hasInElements ("subClass", sub2) ) ;
                               
                              // bind rootClass: UMLClass
                              fujaba__IterGeneralization25ElementsRootClass = generalization25.iteratorOfElements ("superClass") ;
                              while ( fujaba__IterGeneralization25ElementsRootClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterGeneralization25ElementsRootClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    rootClass = (UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(visitorClass.equals (rootClass)) && !(sub2.equals (rootClass)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (rootClass);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization25 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind rootClass: UMLClass
            fujaba__IterGeneralization25ElementsRootClass = generalization25.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization25ElementsRootClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization25ElementsRootClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  rootClass = (UMLClass) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (rootClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
