/*
 * The FUJABA ToolSuite project:
 *
 *   FUJABA is the acronym for 'From Uml to Java And Back Again'
 *   and originally aims to provide an environment for round-trip
 *   engineering using UML as visual programming language. During
 *   the last years, the environment has become a base for several
 *   research activities, e.g. distributed software, database
 *   systems, modelling mechanical and electrical systems and
 *   their simulation. Thus, the environment has become a project,
 *   where this source code is part of. Further details are avail-
 *   able via http://www.fujaba.de
 *
 *      Copyright (C) Fujaba Development Group
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA 02111-1307, USA or download the license under
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * WARRANTY:
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Lesser General Public License for more details.
 *
 * Contact address:
 *
 *   Fujaba Management Board
 *   Software Engineering Group
 *   University of Paderborn
 *   Warburgerstr. 100
 *   D-33098 Paderborn
 *   Germany
 *
 *   URL  : http://www.fujaba.de
 *   email: info@fujaba.de
 *
 */
package de.upb.lib.userinterface;

import java.awt.event.ActionEvent;


/**
 * Action execution listener that receives notification upon failure of an action, too.
 *
 * @author    christian.schneider@uni-kassel.de
 * @version   $Revision: 1.2 $ $Date: 2005/06/13 08:16:38 $
 */
public interface ActionExecutionListenerEx extends ActionExecutionListener
{

   /**
    * This method will be called after actionPerformed was executed if an exception/throwable was thrown.
    *
    * @param e          The action-defined event.
    * @param throwable  the exception/error that occured
    * @return           true if the error was handled (though each listener will be notified)
    */
   public boolean postActionNotify (ActionEvent e, Throwable throwable);
}

/*
 * $Log: ActionExecutionListenerEx.java,v $
 * Revision 1.2  2005/06/13 08:16:38  lowende
 * Removed wrong javadoc syntax.
 *
 */
